
 UNIT UnForStr ; { simple operations with the strings }

 INTERFACE

 Function WordToFixStr ( w  : Word ; n  : Byte ) : string ;

 Function IntegerToFixStr ( w  : Integer ; n  : Byte ) : string ;

 Function FloatToFixStr ( e  : Extended ;  n , k  : Byte ) : string ;

 Function BlanksToStr ( s  : string ; n  : Byte ) : string ;

 Procedure ToEraseSomeBlanks ( Var  sn  : string ) ;

 Procedure ToEraseAllBlanks ( Var  sn  : string ) ;

 Procedure ToReplaceBlanks ( Var  st  : string ) ;

 Function WithOutDecimalPoint ( st  : string ) : string ;

 function WithoutBlanksCopy ( s  : String ) : String ;

 function FloatToSingle ( e  : Extended ;  n  : Byte ) : string ;

 IMPLEMENTATION

 Function WordToFixStr ( w  : Word ; n  : Byte ) : string ;
 Var
   i  : Byte ;
   s  : string ;
 Begin
   Str(w:n,s);
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   WordToFixStr:=s;
 End;

 Function IntegerToFixStr ( w  : Integer ; n  : Byte ) : string ;
 Var
   i  : Byte ;
   s  : string ;
 Begin
   Str(w:n,s);
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   IntegerToFixStr:=s;
 End;

 Function FloatToFixStr ( e  : Extended ;  n , k  : Byte ) : string ;
 Var
   i  : Byte ;
   p  : Byte ;
   s  : string ;
 Begin
   Str(e:n:k,s);
   p:=Pos('-',s);
   If  p > 1
     Then
       Begin
         s[p]:='0';
         s[1]:='-';
       End;
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   FloatToFixStr:=s;
 End;

 Function BlanksToStr ( s : string ; n  : Byte ) : string ;
 Var
   a  : string ;
   l  : Byte ;
 Begin
   a:=s;  { our string }
   l:=Length(a); { length of our sting }
   If  l > n
     Then
       Delete(a,n+1,l-n) { length is greater than necessary }
     Else
       While  l < n  Do  { length of our string is less than necessary }
         Begin { to add blanks if it is needed }
           a:=' '+a; { to add one blank forward }
           If  Length(a) < n  Then  a:=a+' '; { to add one blank backward }
           l:=Length(a);
         End;
   BlanksToStr:=a;
 End;

 Procedure ToEraseSomeBlanks ( Var  sn  : string ) ;
 Var
   i,l  : Byte ;
 Begin
   l:=Length(sn);
   For i:=l DownTo 1 Do
     If  sn[i] = ' '
       Then
         Delete(sn,i,1)
       Else
         Exit;
 End;

 Procedure ToEraseAllBlanks ( Var  sn  : string ) ;
 Var
   n  : Byte ;
 Begin
   n:=Pos(' ',sn);
   While  n > 0  Do
     Begin
       Delete(sn,n,1);
       n:=Pos(' ',sn);
     End;
 End;

 Procedure ToReplaceBlanks ( Var  st  : string ) ;
 Var
   i,l,n     : Byte ;
 Begin
   l:=Length(st);
   For i:=1 To l Do
     If  st[i] = ' '  Then  st[i]:='0';
   n:=Pos('+',st);   { may be plus in string }
   if  n > 1
     then
       begin
         st[1]:='+'; { the first character plus }
         st[n]:='0'; { replace by nullo }
       end;
   n:=Pos('-',st);   { may be minus in string }
   if  n > 1
     then
       begin
         st[1]:='-'; { the first character minus }
         st[n]:='0'; { replace by nullo }
       end;
 End;

 Function WithOutDecimalPoint ( st  : string ) : string ;
 Var
   n  : Byte ;
   s  : string ;
 Begin
   s:=st;
   n:=Pos('.',s);
   While  n > 0  Do
     Begin
       Delete(s,n,1);
       n:=Pos('.',s);
     End;
   WithOutDecimalPoint:=s;
 End;

 { to use only the first twenty character from string s
   and to erase some blanks forward and backward for new string }

 function WithoutBlanksCopy ( s  : String ) : String ;
 var
   l  : Byte ;   { length of string }
   n  : Byte ;   { position of character blank }
   a  : String ; { temporary string }
 begin
   a:=Copy(s,1,20); { only the first twenty character }
   l:=Length(a);    { length may be less than 20 character }
   n:=Pos(' ',a);   { may be blank forward }
   while  ( n = 1 ) and ( l > 1 )  do { if blank forward yes }
     begin
       Delete(a,1,1);                 { to delete this blank }
       n:=Pos(' ',a);                 { may be blank forward }
       l:=Length(a);                  { new value length of our string }
     end;
 repeat                   { from the end of string }
   if  a[l] = ' '         { blank may be as the last symbol }
     then  Delete(a,l,1)  { to delete this blank }
     else  n:=0;          { this is symbolbut not blank }
   l:=Length(a);          { length of string }
 until  ( n = 0 ) or ( l = 1 ) ; { finish }
   WithoutBlanksCopy:=a; { our string without blanks }
 end;

 function FloatToSingle ( e  : Extended ;  n  : Byte ) : string ;
 var
   s  : string ;
 begin
   Str(e:n,s);       { float to string in form a.aaa..aaE+xxxx }
   s[n-5]:='e';      { to change big E by small e power }
   Delete(s,n-3,2);  { to string in single form a.aaa..aaE+xx }
   FloatToSingle:=s; { result }
 end;

 END.
