unit UnIncIni ; { for initial data to record inclination case }
interface
procedure IncSimple ; { -[x/r*x'/r'+y/r*y'/r'+z/r*z'/r'] to rowcoh^ }
implementation
uses
  UnTypVar , { for var rowone rowtwo of TRowPtr }
  UnRowIni , { for recnul of type TRowVar }
  UnRowLow , { for LowerRow procedure from rowtre to rowone or rowtwo }
  UnRowMul ; { for MultForRow procedure }
{ in our case
  x/r=+(1/r)*[r*cos(v)]*[-1/2*cos(g-h)+1/2*cos(g+h)
                         +1/2*cos(g-h)*cos(i)+1/2*cos(g+h)*cos(i) ]
      +(1/r)*[r*sin(v)]*[+1/2*sin(g-h)-1/2*sin(g+h)
                         -1/2*sin(g-h)*cos(i)-1/2*sin(g+h)*cos(i) ]
  where
         r*cos(v) = a*[cos(E)-e]
         r*sin(v) = a*sqrt(1-e^2)*sin(E)
  it is possible to obtain our row for x/r by simple multiplication }
procedure ForXdivRone ;   { x/r   to rowone with E anomaly }
var
  m  : word ;
begin
  { nullo initial to array rowtre^[..] mectre = 0 }
  RowTreNul ;              { UnRowIni nullo to array rowtre }
  { the first part with cosinus
    +cos(v)*[-1/2*cos(g-h)+1/2*cos(g+h)
             +1/2*cos(g-h)*cos(i)+1/2*cos(g+h)*cos(i) ]
    to fill rowone for multiplication
    [r*cos(v)]/r = a*(1/r)*cos(E) - a*(1/r)*e }
  mecone:=2;               { only two terms }
  rowone^[1]:=recnul;      { unrowini nullo initial 'C' }
  rowone^[2]:=recnul;      { unrowini nullo initial 'C' }
  { the first term a*(1/r)*cos(E) }
  rowone^[1].amp[1]:=1.0;  { amplitude }
  rowone^[1].mec[9]:=+1;   { power for a }
  rowone^[1].mec[11]:=-1;  { power for 1/r }
  rowone^[1].mar[2]:=+1;   { angle +E with cosinus }
  { the second term -a*(1/r)*e }
  rowone^[2].amp[1]:=-1.0; { amplitude }
  rowone^[2].mec[2]:=+1;   { power for e }
  rowone^[2].mec[9]:=+1;   { power for a }
  rowone^[2].mec[11]:=-1;  { power for 1/r }
  { to fill rowtwo
       -1/2*cos(g-h)
       +1/2*cos(g+h)
       +1/2*cos(g-h)*cos(i)
       +1/2*cos(g+h)*cos(i) }
  mectwo:=4;             { four terms }
  for m:=1 to mectwo do  { for all terms }
    rowtwo^[m]:=recnul;  { nullo initial global UnRowIni }
  { the first term -1/2*cos(g-h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[1].amp[1]:=-0.5;  { amplitude -1/2 }
  rowtwo^[1].mar[3]:=+1;    { +g }
  rowtwo^[1].mar[4]:=-1;    { -h }
  { the second term +1/2*cos(g+h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[2].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[2].mar[3]:=+1;    { +g }
  rowtwo^[2].mar[4]:=+1;    { +h }
  { the third term +1/2*cos(g-h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[3].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[3].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[3].mar[3]:=+1;    { +g }
  rowtwo^[3].mar[4]:=-1;    { -h }
  { the fourth term +1/2*cos(g+h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[4].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[4].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[4].mar[3]:=+1;    { +g }
  rowtwo^[4].mar[4]:=+1;    { +h }
  { to multiply rowone^ * rowtwo^ = rowtre^ }
  MultForRow(+1.0); { UnRowMul result to rowtre^ mectre terms }
  { the second part with sinus
    +sin(v)*[+1/2*sin(g-h)-1/2*sin(g+h)
             -1/2*sin(g-h)*cos(i)-1/2*sin(g+h)*cos(i) ]
    to fill rowone for multiplication
    [r*sin(v)]/r = a*(1/r)*sqrt(1-e^2)*sin(E) }
  mecone:=1;               { one term }
  rowone^[1]:=recnul;      { unrowini nullo initial 'C' }
  { the first term a*(1/r)*sqrt(1-e^2)*sin(E) }
  rowone^[1].amp[1]:=1.0;  { amplitude }
  rowone^[1].mec[1]:=-1;   { power for 1/sqrt(1-e^2) }
  rowone^[1].mec[9]:=+1;   { power for a }
  rowone^[1].mec[11]:=-1;  { power for 1/r }
  rowone^[1].mar[2]:=+1;   { angle E with sinus }
  rowone^[1].fcs:='S';     { function sinus }
  { to fill rowtwo
       +1/2*sin(g-h)
       -1/2*sin(g+h)
       -1/2*sin(g-h)*cos(i)
       -1/2*sin(g+h)*cos(i) }
  mectwo:=4;             { four terms }
  for m:=1 to mectwo do  { for all terms }
    rowtwo^[m]:=recnul;  { nullo initial global UnRowIni }
  { the first term +1/2*sin(g-h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[1].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[1].mar[3]:=+1;    { +g }
  rowtwo^[1].mar[4]:=-1;    { -h }
  rowtwo^[1].fcs:='S';      { function sinus }
  { the second term -1/2*sin(g+h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[2].amp[1]:=-0.5;  { amplitude -1/2 }
  rowtwo^[2].mar[3]:=+1;    { +g }
  rowtwo^[2].mar[4]:=+1;    { +h }
  rowtwo^[2].fcs:='S';      { function sinus }
  { the third term -1/2*sin(g-h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[3].amp[1]:=-0.5;  { amplitude -1/2 }
  rowtwo^[3].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[3].mar[3]:=+1;    { +g }
  rowtwo^[3].mar[4]:=-1;    { -h }
  rowtwo^[3].fcs:='S';      { function sinus }
  { the fourth term -1/2*sin(g+h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[4].amp[1]:=-0.5;  { amplitude -1/2 }
  rowtwo^[4].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[4].mar[3]:=+1;    { +g }
  rowtwo^[4].mar[4]:=+1;    { +h }
  rowtwo^[4].fcs:='S';      { function sinus }
  { to multiply rowone^ * rowtwo^ = to add to rowtre^ }
  MultForRow(+1.0); { UnRowMul result to rowtre^ mectre terms }
  LowerRow(1); { from rowtre^ to rowone^ all terms UnRowLow }
end;
{ in our case
  y/r=+(1/r)*[r*cos(v)]*[+1/2*sin(g-h)+1/2*sin(g+h)
                         -1/2*sin(g-h)*cos(i)+1/2*sin(g+h)*cos(i) ]
      +(1/r)*[r*sin(v)]*[+1/2*cos(g-h)+1/2*cos(g+h)
                         -1/2*cos(g-h)*cos(i)+1/2*cos(g+h)*cos(i) ]
  where
         r*cos(v) = a*[cos(E)-e]
         r*sin(v) = a*sqrt(1-e^2)*sin(E)
  it is possible to obtain our row for x/r by simple multiplication }
procedure ForYdivRone ;   { y/r   to rowone with E anomaly }
var
  m  : word ;
begin
  { nullo initial to array rowtre^[..] mectre = 0 }
  RowTreNul ;              { UnRowIni nullo to array rowtre }
  { the first part with cosinus
    +cos(v)*[+1/2*sin(g-h)+1/2*sin(g+h)
             -1/2*sin(g-h)*cos(i)+1/2*sin(g+h)*cos(i) ]
    to fill rowone for multiplication
    [r*cos(v)]/r = a*(1/r)*cos(E) - a*(1/r)*e }
  mecone:=2;               { only two terms }
  rowone^[1]:=recnul;      { unrowini nullo initial 'C' }
  rowone^[2]:=recnul;      { unrowini nullo initial 'C' }
  { the first term a*(1/r)*cos(E) }
  rowone^[1].amp[1]:=1.0;  { amplitude }
  rowone^[1].mec[9]:=+1;   { power for a }
  rowone^[1].mec[11]:=-1;  { power for 1/r }
  rowone^[1].mar[2]:=+1;   { angle +E with cosinus }
  { the second term -a*(1/r)*e }
  rowone^[2].amp[1]:=-1.0; { amplitude }
  rowone^[2].mec[2]:=+1;   { power for e }
  rowone^[2].mec[9]:=+1;   { power for a }
  rowone^[2].mec[11]:=-1;  { power for 1/r }
  { to fill rowtwo
       =1/2*sin(g-h)
       +1/2*sin(g+h)
       -1/2*sin(g-h)*cos(i)
       +1/2*sin(g+h)*cos(i) }
  mectwo:=4;             { four terms }
  for m:=1 to mectwo do  { for all terms }
    rowtwo^[m]:=recnul;  { nullo initial global UnRowIni }
  { the first term +1/2*sin(g-h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[1].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[1].mar[3]:=+1;    { +g }
  rowtwo^[1].mar[4]:=-1;    { -h }
  rowtwo^[1].fcs:='S';      { function sinus }
  { the second term +1/2*sin(g+h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[2].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[2].mar[3]:=+1;    { +g }
  rowtwo^[2].mar[4]:=+1;    { +h }
  rowtwo^[2].fcs:='S';      { function sinus }
  { the third term -1/2*sin(g-h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[3].amp[1]:=-0.5;  { amplitude -1/2 }
  rowtwo^[3].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[3].mar[3]:=+1;    { +g }
  rowtwo^[3].mar[4]:=-1;    { -h }
  rowtwo^[3].fcs:='S';      { function sinus }
  { the fourth term +1/2*sin(g+h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[4].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[4].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[4].mar[3]:=+1;    { +g }
  rowtwo^[4].mar[4]:=+1;    { +h }
  rowtwo^[4].fcs:='S';      { function sinus }
  { to multiply rowone^ * rowtwo^ = rowtre^ }
  MultForRow(+1.0); { UnRowMul result to rowtre^ mectre terms }
  { the second part with sinus
    +sin(v)*[+1/2*cos(g-h)+1/2*cos(g+h)
             -1/2*cos(g-h)*cos(i)+1/2*cos(g+h)*cos(i) ]
    to fill rowone for multiplication
    [r*sin(v)]/r = a*(1/r)*sqrt(1-e^2)*sin(E) }
  mecone:=1;               { one term }
  rowone^[1]:=recnul;      { unrowini nullo initial 'C' }
  { the first term a*(1/r)*sqrt(1-e^2)*sin(E) }
  rowone^[1].amp[1]:=1.0;  { amplitude }
  rowone^[1].mec[1]:=-1;   { power for 1/sqrt(1-e^2) }
  rowone^[1].mec[9]:=+1;   { power for a }
  rowone^[1].mec[11]:=-1;  { power for 1/r }
  rowone^[1].mar[2]:=+1;   { angle E with sinus }
  rowone^[1].fcs:='S';     { function sinus }
  { to fill rowtwo
       +1/2*cos(g-h)
       +1/2*cos(g+h)
       -1/2*cos(g-h)*cos(i)
       +1/2*cos(g+h)*cos(i) }
  mectwo:=4;             { four terms }
  for m:=1 to mectwo do  { for all terms }
    rowtwo^[m]:=recnul;  { nullo initial global UnRowIni }
  { the first term +1/2*cos(g-h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[1].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[1].mar[3]:=+1;    { +g }
  rowtwo^[1].mar[4]:=-1;    { -h }
  rowtwo^[1].fcs:='C';      { function cosinus }
  { the second term +1/2*cos(g+h)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[2].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[2].mar[3]:=+1;    { +g }
  rowtwo^[2].mar[4]:=+1;    { +h }
  rowtwo^[2].fcs:='C';      { function cosinus }
  { the third term -1/2*cos(g-h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[3].amp[1]:=-0.5;  { amplitude -1/2 }
  rowtwo^[3].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[3].mar[3]:=+1;    { +g }
  rowtwo^[3].mar[4]:=-1;    { -h }
  rowtwo^[3].fcs:='C';      { function cosinus }
  { the fourth term +1/2*cos(g+h)*cos(i)
    other positions mec[..] mar[..] default fcs='C' }
  rowtwo^[4].amp[1]:=+0.5;  { amplitude +1/2 }
  rowtwo^[4].mec[4]:=+1;    { power cos(i)^1 }
  rowtwo^[4].mar[3]:=+1;    { +g }
  rowtwo^[4].mar[4]:=+1;    { +h }
  rowtwo^[4].fcs:='C';      { function cosinus }
  { to multiply rowone^ * rowtwo^ = rowtre^ }
  MultForRow(+1.0); { UnRowMul result to rowtre^ mectre terms }
  LowerRow(1); { from rowtre^ to rowone^ all terms UnRowLow }
end;
{ in our case
  z/r=+(1/r)*[r*cos(v)]*[-cos(g)*sin(i)]
      +(1/r)*[r*sin(v)]*[+sin(g)*sin(i)]
  where
         r*cos(v) = a*[cos(E)-e]
         r*sin(v) = a*sqrt(1-e^2)*sin(E)
  it is possible to obtain our row for x/r by simple multiplication }
procedure ForZdivRone ;   { z/r   to rowone with E anomaly }
begin
  { nullo initial to array rowtre^[..] mectre = 0 }
  RowTreNul ;              { UnRowIni nullo to array rowtre }
  { the first part with cosinus
    +cos(v)*[-cos(g)*sin(i)]
    to fill rowone for multiplication
    [r*cos(v)]/r = a*(1/r)*cos(E) - a*(1/r)*e }
  mecone:=2;               { only two terms }
  rowone^[1]:=recnul;      { unrowini nullo initial 'C' }
  rowone^[2]:=recnul;      { unrowini nullo initial 'C' }
  { the first term a*(1/r)*cos(E) }
  rowone^[1].amp[1]:=1.0;  { amplitude }
  rowone^[1].mec[9]:=+1;   { power for a }
  rowone^[1].mec[11]:=-1;  { power for 1/r }
  rowone^[1].mar[2]:=+1;   { angle +E with cosinus }
  { the second term -a*(1/r)*e }
  rowone^[2].amp[1]:=-1.0; { amplitude }
  rowone^[2].mec[2]:=+1;   { power for e }
  rowone^[2].mec[9]:=+1;   { power for a }
  rowone^[2].mec[11]:=-1;  { power for 1/r }
  { to fill rowtwo -cos(g)*sin(i) }
  mectwo:=1;               { one term }
  rowtwo^[1]:=recnul;      { initial }
  rowtwo^[1].amp[1]:=-1.0; { amplitude }
  rowtwo^[1].mec[3]:=+1;   { power for sin(i) }
  rowtwo^[1].mar[3]:=+1;   { argument g }
  rowtwo^[1].fcs:='C';     { function cosinus }
  { to multiply rowone^ * rowtwo^ = rowtre^ }
  MultForRow(+1.0); { UnRowMul result to rowtre^ mectre terms }
  { the second part with sinus
    +sin(v)*[+sin(g)*sin(i)]
    to fill rowone for multiplication
    [r*sin(v)]/r = a*(1/r)*sqrt(1-e^2)*sin(E) }
  mecone:=1;               { one term }
  rowone^[1]:=recnul;      { unrowini nullo initial 'C' }
  { the first term a*(1/r)*sqrt(1-e^2)*sin(E) }
  rowone^[1].amp[1]:=1.0;  { amplitude }
  rowone^[1].mec[1]:=-1;   { power for 1/sqrt(1-e^2) }
  rowone^[1].mec[9]:=+1;   { power for a }
  rowone^[1].mec[11]:=-1;  { power for 1/r }
  rowone^[1].mar[2]:=+1;   { angle E with sinus }
  rowone^[1].fcs:='S';     { function sinus }
  { to fill rowtwo +sin(g)*sin(i) }
  mectwo:=1;               { one term }
  rowtwo^[1]:=recnul;      { initial }
  rowtwo^[1].amp[1]:=+1.0; { amplitude }
  rowtwo^[1].mec[3]:=+1;   { power for sin(i) }
  rowtwo^[1].mar[3]:=+1;   { argument g }
  rowtwo^[1].fcs:='S';     { function sinus }
  { to multiply rowone^ * rowtwo^ = rowtre^ }
  MultForRow(+1.0); { UnRowMul result to rowtre^ mectre terms }
  LowerRow(1); { from rowtre^ to rowone^ all terms UnRowLow }
end;
procedure ForXdivRtwo ;    { x'/r' }
var
  k,m  : Byte ;
begin
  k:=8;                    { number for x'/r' with prime }
  mectwo:=3;               { in this version  u~=v+g O~=h }
  for m:=1 to mectwo do    { only three terms with cosinus }
    rowtwo^[m]:=recnul;    { nullo from UnRowIni }
  rowtwo^[2].amp[1]:=-0.5; { -1/2 * (1-cos(i)) * cos(u~-O~) }
  rowtwo^[2].mec[k]:=+1;   { (1-cos(i))^1 }
  rowtwo^[2].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[2].mar[k-1]:=+1; { +u~=v+g for g }
  rowtwo^[2].mar[k]:=-1;   { -O~ = h }
  rowtwo^[1].amp[1]:=+1.0; { +cos(u~+O~) }
  rowtwo^[1].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[1].mar[k-1]:=+1; { +u~=v+g for g }
  rowtwo^[1].mar[k]:=+1;   { +O~ = h }
  rowtwo^[3].amp[1]:=-0.5; { -1/2 * (1-cos(i)) * cos(u~+O~) }
  rowtwo^[3].mec[k]:=+1;   { (1-cos(i))^1 }
  rowtwo^[3].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[3].mar[k-1]:=+1; { +u~=v+g for g }
  rowtwo^[3].mar[k]:=+1;   { +O~ = h }
end;
procedure ForYdivRtwo ;    { y'/r' }
var
  k,m  : Byte ;
begin
  k:=8;                    { number for y'/r' with prime }
  mectwo:=3;               { but in this version u~=v+g }
  for m:=1 to mectwo do    { only three terms with sinus }
    rowtwo^[m]:=recnul;    { nullo from UnTypVar }
  rowtwo^[2].amp[1]:=+0.5; { +1/2 * (1-cos(i)) * sin(u~-O~) }
  rowtwo^[2].mec[k]:=+1;   { (1-cos(i))^1 }
  rowtwo^[2].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[2].mar[k-1]:=+1; { +u~=v+g for g }
  rowtwo^[2].mar[k]:=-1;   { -O~ = h }
  rowtwo^[2].fcs:='S';     { sinus function }
  rowtwo^[1].amp[1]:=+1.0; { sin(u~+O~) }
  rowtwo^[1].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[1].mar[k-1]:=+1; { +u~=v+g for g }
  rowtwo^[1].mar[k]:=+1;   { +O~ = h }
  rowtwo^[1].fcs:='S';     { sinus function }
  rowtwo^[3].amp[1]:=-0.5; { -1/2 * (1-cos(i)) * sin(u~+O~) }
  rowtwo^[3].mec[k]:=+1;   { (1-cos(i))^1 }
  rowtwo^[3].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[3].mar[k-1]:=+1; { +u~=v+g for g }
  rowtwo^[3].mar[k]:=+1;   { +O~ = h }
  rowtwo^[3].fcs:='S';     { sinus function }
end;
procedure ForZdivRtwo ; { z'/r' = -sin(i')*cos(v'+g') }
var
  k  : Byte ;
begin
  k:=8;                    { number for z'/r' with prime }
  mectwo:=1;               { in this version u~=v+g }
  rowtwo^[1]:=recnul;      { only one terms with cosinus }
  rowtwo^[1].amp[1]:=-1.0; { amplitude = -1 }
  rowtwo^[1].mec[k-1]:=+1; { sin(i)^1 }
  rowtwo^[1].mar[k-3]:=+1; { +u~=v+g for v }
  rowtwo^[1].mar[k-1]:=+1; { +u~=v+g for g }
end;
procedure IncSimple ; { -[x/r*x'/r'+y/r*y'/r'+z/r*z'/r'] to rowcoh^ }
var
  a  : extended ;   { simple factor equal -1.0 }
begin
  a:=-1.0;          { from plus to minus  -x'/r' -y'/r' -z'/r' }
  maxsum:=numsum;   { global untypvar power for giant planet }
  ForXdivRone ;     { x/r   to rowone^ }
  ForXdivRtwo ;     { x'/r' to rowtwo^ but factor -1.0 is necessary }
  RowTreNul ;       { UnRowIni initial nullo rowtre^ mectre=0 }
  MultForRow(a);    { rowone * rowtwo  result in rowtre UnRowMul }
  TreToCosH ;       { UnRowLow result from rowtre^ to keep in rowcoh^ }
  ForYdivRone ;     { y/r   to rowone }
  ForYdivRtwo ;     { y'/r' to rowtwo but factor -1.0 is necessary }
  CosHtoTre ;       { UnRowLow to return current terms to rowtre^ }
  MultForRow(a);    { rowone * rowtwo  result in rowtre UnRowMul }
  TreToCosH ;       { result from rowtre^ to keep in rowcoh^ }
  ForZdivRone ;     { z/r   to rowone }
  ForZdivRtwo ;     { z'/r' to rowtwo but factor -1.0 is necessary }
  CosHtoTre ;       { UnRowLow to return current terms to rowtre^ }
  MultForRow(a);    { rowone * rowtwo  result in rowtre UnRowMul }
  TreToCosH ;       { result from rowtre^ to keep in rowcoh^ }
end;
end.
