unit unitseqs;

interface

uses
  Forms ,
  Graphics ,
  SysUtils ,  // for function IntToStr
  unitseqt ;  // for TBoxer

var
  pb1,pb2,pb3,pb4,pb5,pb6  : TBoxer ; { type UnitSeqt }

procedure ForElemGraQ ;

procedure ForElemGraS ;

implementation

uses
  unsequgr , // for fmThous
  unforstr ; // for function FloatToFixStr

var
  StrElem   : ShortString ;
  StrValue  : ShortString ;
  xa,ya,xm,ym  : Integer ;
  xb,yb,xc,yc  : Integer ;
  vc  : Extended ;

procedure ArrowX ( x , y  : Integer ) ;
var
  i  : Integer ;
begin
  for i:=0 to 6 do
    begin
      fmThous.Canvas.Pixels[x-i,y+i div 2]:=clBlack;
      fmThous.Canvas.Pixels[x-i,y-i div 2]:=clBlack;
    end;
end;

procedure ArrowY ( x , y  : Integer ) ;
var
  i  : Integer ;
begin
  for i:=0 to 6 do
    begin
      fmThous.Canvas.Pixels[x+i div 2,y+i]:=clBlack;
      fmThous.Canvas.Pixels[x-i div 2,y+i]:=clBlack;
    end;
end;

function MaxMinValue ( n  : Byte ;  v  : Extended ) : ShortString ;
var
  s  : ShortString ;
begin
  s:='';
  case  n  of
    1 : s:=FloatToFixStr(v,6,4); { eccentricity }
    3 : s:=FloatToFixStr(v,5,2); { inclination }
    2 , 4 : { arg. perihelium and ascending node }
      if  v < -100.0       { -180 degree }
        then  s:=' '+FloatToFixStr(v,6,1) { -180 degree }
        else
          if  v < +100.0    { 0 degree }
            then  s:='    '+FloatToFixStr(v,3,1) { 0 degree }
            else  s:='  '+FloatToFixStr(v,5,1);  { +180 degree }
    5 : if  v < 10.0
          then
            s:=FloatToFixStr(v,6,4) { semimajor axis < 10.0 AU }
          else
            s:=FloatToFixStr(v,5,3) { semimajor axis > 10.0 AU }
  end; { case n }
  if  Length(s) = 5  then  s:='  '+s;
  MaxMinValue:=s;
end;

procedure ForShortLineX ( ip  : Byte ;  pb  : TBoxer ) ;
var
  k : Word ;
begin
  xa:=pb.x1+40;
  xm:=pb.x2-pb.x1-60;
  yc:=pb.y2-20;
  vc:=0.0;
  k:=0;
repeat
  xc:=xa+Round(xm*(vc/difanv));
  fmThous.Canvas.MoveTo(xc,yc);
  if  ( k mod 5 = 0 ) // difmax = 10000 year only
    then
      fmThous.Canvas.LineTo(xc,yc-10)
    else
      if  xc < xb
        then
          fmThous.Canvas.LineTo(xc,yc-6);
  if  difmax > 1.2e3
    then  vc:=vc+1.0e3  { step one thousand years }
    else  vc:=vc+1.0e2; { step one hundred years }
  StrValue:=IntToStr(k);
  xc:=xc-3;
  if  ( ip = 0 ) and ( k mod 5 = 0 )
    then { step 5000 year }
      if  k < 10
        then
          fmThous.Canvas.TextOut(xc,yc+2,StrValue)
        else
          fmThous.Canvas.TextOut(xc-3,yc+2,StrValue);
  k:=k+1;     { step one thousand year }
until  vc > difanv+1.0e2;
end;

procedure ForTitleLineX ( pb  : TBoxer ) ;
var
  strx  : ShortString ;
begin
  if  difmax > 1.2e3
    then  strx:=' '
    else  strx:=' ';
  xm:=fmThous.Canvas.TextWidth(strx);
  ym:=fmThous.Canvas.TextHeight(strx);
  xc:=pb.x2-20-xm;
  yc:=pb.y1+ym;
  fmThous.Canvas.TextOut(xc,yc,strx);
end;

procedure ForShortLines ( n  : Byte ;  pb  : TBoxer ) ;
begin
  xa:=pb.x1+40;
  ya:=pb.y1+30;
  xm:=pb.x2-pb.x1-60;
  ym:=pb.y2-pb.y1-60;
  xc:=xa;
  vc:=valmax[n]-valnul[n];
  yc:=ya+(ym div 2)-Round(0.5*ym*(vc/(valmax[n]-valnul[n])));
  fmThous.Canvas.MoveTo(xc,yc);
  fmThous.Canvas.LineTo(xc+8,yc);
  StrValue:=MaxMinValue(n,valmax[n]);
  fmThous.Canvas.TextOut(pb.x1+2,yc-6,StrValue);
  vc:=valnul[n]-valnul[n];
  yc:=ya+(ym div 2)-Round(0.5*ym*(vc/(valmax[n]-valnul[n])));
  fmThous.Canvas.MoveTo(xc,yc);
  fmThous.Canvas.LineTo(xc+8,yc);
  StrValue:=MaxMinValue(n,valnul[n]);
  fmThous.Canvas.TextOut(pb.x1+2,yc-6,StrValue);
  vc:=valmin[n]-valnul[n];
  yc:=ya+(ym div 2)-Round(0.5*ym*(vc/(valmax[n]-valnul[n])));
  fmThous.Canvas.MoveTo(xc,yc);
  fmThous.Canvas.LineTo(xc+8,yc);
  StrValue:=MaxMinValue(n,valmin[n]);
  fmThous.Canvas.TextOut(pb.x1+2,yc-6,StrValue);
end;

procedure LineNum ( pb  : TBoxer ) ;
begin
  xa:=pb.x1+40;
  ya:=pb.y1+15;
  xm:=pb.x2-pb.x1-50;
  ym:=pb.y2-pb.y1-35;
  xb:=xa+xm;
  yb:=ya+ym;
  fmThous.Canvas.MoveTo(xa,yb);
  fmThous.Canvas.LineTo(xa,ya);
  fmThous.Canvas.MoveTo(xa,yb);
  fmThous.Canvas.LineTo(xb,yb);
  ArrowX(xb,yb);
  ArrowY(xa,ya);
  xc:=pb.x1+10;
  yc:=pb.y1+2;
  fmThous.Canvas.TextOut(xc,yc,StrName+'  '+StrElem);
end;

procedure ForAllLines ;
var
  n  : Byte ;
  s  : ShortString ;
begin
  s:='';
  for n:=1 to 6 do
    begin
      case  n  of
        2 : begin
              StrElem:=''+s;
              LineNum(pb2);
              ForShortLines(1,pb2);
              ForShortLineX(0,pb2);
              ForTitleLineX(pb2);
            end;
        3 : begin
              StrElem:='  (.)'+s;
              LineNum(pb3);
              ForShortLines(2,pb3);
              ForShortLineX(0,pb3);
              ForTitleLineX(pb3);
            end;
        5 : begin
              StrElem:='  (.)'+s;
              LineNum(pb5);
              ForShortLines(3,pb5);
              ForShortLineX(0,pb5);
              ForTitleLineX(pb5);
            end;
        6 : begin
              StrElem:='  (.)'+s;
              LineNum(pb6);
              ForShortLines(4,pb6);
              ForShortLineX(0,pb6);
              ForTitleLineX(pb6);
            end;
      end; // case n
    end;
end;

procedure ForSecLines ;
var
  n  : Byte ;
  s  : ShortString ;
begin
  s:='';
  for n:=1 to 1 do
    begin
      case  n  of
        1 : begin
              StrElem:='  ()'+s;
              LineNum(pb1);
              ForShortLines(5,pb1);
              ForShortLineX(0,pb1);
              ForTitleLineX(pb1);
            end;
        4 : begin
              StrElem:='  ()'+s;
              LineNum(pb4);
              ForShortLines(5,pb4);
              ForShortLineX(0,pb4);
              ForTitleLineX(pb4);
            end;
      end; // case n
    end;
end;

procedure BoxNumber ( pb  : TBoxer ) ;
begin
  xa:=pb.x1+40;
  ya:=pb.y1+30;
  xm:=pb.x2-pb.x1-60;
  ym:=pb.y2-pb.y1-60;
end;

procedure ForAllPoints ;
var
  i  : byte ; { simple count for strings }
  k  : Byte ;
  n  : Byte ;
  s  : string[16] ; { with the name of satellite }
begin
  valelm[7]:=0.0;
  ReSet(grfile); // from unit unitseqt
  for i:=1 to 2 do  readln(grfile); { with information }
  readln(grfile,s); { name of the satellite }
  StrName:=s;
  for i:=4 to 10 do  readln(grfile); { the first ten strings }
  while  ( not EOF(grfile) ) and ( valelm[7] < difmax )  do
    begin
      with  grelem  do
        begin
          readln(grfile,t,a,e,gi,gn,gp);
          if   e < 0.0  then   e:=-e;
          if  gi < 0.0  then  gi:=-gi;
          if  gn < 0.0  then  gn:=360.0+gn;
          if  gp < 0.0  then  gp:=360.0+gp;
        end;
      valelm[7]:=grelem.t/365.25-valmin[7];
      n:=2;
      k:=1;
      while  n < 7  do
        begin
          case  n  of
            2 : begin { eccentricity }
                  k:=1;
                  valelm[k]:=grelem.e;
                  BoxNumber(pb2);
                end;
            3 : begin { argument of perihelium }
                  k:=2;
                  valelm[k]:=grelem.gp;
                  BoxNumber(pb3);
                end;
            5 : begin { inclination }
                  k:=3;
                  valelm[k]:=grelem.gi;
                  BoxNumber(pb5);
                end;
            6 : begin { the ascending node }
                  k:=4;
                  valelm[k]:=grelem.gn;
                  BoxNumber(pb6);
                end;
          end; // case n
          if  n <> 4
            then
              begin
                vc:=valelm[k]-valnul[k];
                xc:=xa+Round(xm*(valelm[7]/difanv));
                yc:=ya+(ym div 2)
                      -Round(0.5*ym*(vc/(valmax[k]-valnul[k])));
                fmThous.Canvas.Pixels[xc,yc]:=clBlack;
              end;
          n:=n+1;
        end;
    end;
end;

procedure ForSecPoints ;
var
  i  : Byte ;
  k  : Byte ;
  y  : integer ;    { for the coordinate on diagram }
  a  : string[20] ; { main planet name }
  b  : string[16] ; { may be number or name satellite }
  s  : string[16] ; { satellite identification }
begin
  valelm[7]:=0.0;
  ReSet(grfile); // from unit unitsegt
  readln(grfile,a); { main planet name }
  readln(grfile,b); { may by number or name }
  readln(grfile,s); { identification of the satellite }
  StrName:=s;
  for i:=4 to 10 do  readln(grfile); { the first ten strings }
  while  ( not EOF(grfile) ) and ( valelm[7] < difmax )  do
    begin
      with  grelem  do  { for the semimajor axis }
        begin
          readln(grfile,t,a,e,gi,gn,gp);
          if   e < 0.0  then   e:=-e;
          if  gi < 0.0  then  gi:=-gi;
          if  gn < 0.0  then  gn:=360.0+gn;
          if  gp < 0.0  then  gp:=360.0+gp;
        end;
      valelm[7]:=grelem.t/365.25-valmin[7];
      k:=5;
      valelm[k]:=grelem.a;
      BoxNumber(pb1);
      vc:=valelm[k]-valnul[k];
      xc:=xa+Round(xm*(valelm[7]/difanv));
      yc:=ya+(ym div 2)-Round(0.5*ym*(vc/(valmax[k]-valnul[k])));
      fmThous.Canvas.Pixels[xc,yc]:=clBlack;
    end;
  BoxNumber(pb4); { for information about satellite }
  y:=pb4.y1+((pb4.y2-pb4.y1) div 2);
  fmThous.Canvas.TextOut(xa+20,y-60,'  '+a);
  fmThous.Canvas.TextOut(xa+20,y-40,'  '+s+'  '+b);
  fmThous.Canvas.TextOut(xa+20,y-20,'     '+StrFile);
  fmThous.Canvas.TextOut(xa+20,y,       { unitseqt }
         '    -  '+IntToStr(Round(difanv))+'  ');
  if  ( ( valmin[2] > 10.0 ) and ( valmax[2] < 350.0 ) )
    then
      fmThous.Canvas.TextOut(xa+20,y+20,
             '  -    ')
    else
      fmThous.Canvas.TextOut(xa+20,y+20,
             '  -    ');
  fmThous.Canvas.TextOut(xa+20,y+40,       { unitseqt }
         ' ( 2000.0)');
end;

procedure ForElemGraQ ;
begin // function  ToOpenBinFile from unitseqt
  if  not ToOpenTxtFile(StrFile)  then  Exit ; // no action
  ToGetGraphParm ; // from unitseqt values for graphic
  ForAllLines ;
  ForAllPoints ;
  ToCloseTxtFile ; // from unit unitseqt
end;

procedure ForElemGraS ; { for the semimajor axis }
begin // function  ToOpenBinFile from unitseqt
  if  not ToOpenTxtFile(StrFile)  then  Exit ; // no action
  ToGetGraphParm ; // from unitseqt values for graphic
  ForSecLines ;
  ForSecPoints ;
  ToCloseTxtFile ; // from unit unitseqt
end;

end.
