unit unitseqt;

interface

type
  TBoxer = record
             x1,y1,x2,y2  : Integer ;
           end;

type
  TElementsBin = record   // year and kepler elements
                   t,a,e,gi,gn,gp  : Double ;  // rec
                 end;

var
  boocomp  : Boolean ;     // to compare with numerical integration
  booaxis  : Boolean ;     // information about planets semiaxes
  StrFile  : ShortString ; // name of file with result
  StrFils  : ShortString ; // name of file with SecPert result
  StrFipe  : ShortString ; // name of file with result
  StrFips  : ShortString ; // name of file with SecPert result

var
  grfile  : TextFile ;
  grelem  : TElementsBin ;
  valelm  : array [1..7] of Extended ;
  valmin  : array [1..7] of Extended ;
  valmax  : array [1..7] of Extended ;
  valnul  : array [1..7] of Extended ;
  difanv  : Extended ;
  scalet  : Extended ;
  difmax  : Extended ;

var
  StrName : ShortString ; { title on figures about object }

const
  difarr  : Array[1..8] of Extended =
          ( 1.0e5 , 1.0e6 , 2.0e6 ,
            3.0e6 , 6.0e6 , 1.0e7 ,
            1.5e7 , 2.3e7 ) ;

function ToOpenTxtFile ( strf  : ShortString ) : Boolean ;

procedure ToCloseTxtFile ;

procedure ToGetGraphParm ;

implementation

function ToOpenTxtFile ( strf  : ShortString ) : Boolean ;
begin
  AssignFile(grfile,strf);
{$I-}
  ReSet(grfile);
{$I+}
  if  IOResult = 0
    then
      ToOpenTxtFile:=True
    else
      ToOpenTxtFile:=False;
end;

procedure ToCloseTxtFile ;
begin
  CloseFile(grfile);
end;

procedure ToGetGraphParm ;
var
  i  : Byte ;
  s  : string[16] ;
begin
  for i:=1 To 7 do
    begin
      valmax[i]:=-1.0e10;
      valmin[i]:=+1.0e10;
    end;
  difanv:=valmax[7]-valmin[7];
  ReSet(grfile);
  for i:=1 to 2 do  { with information }
    readln(grfile);  { the first ten string }
  readln(grfile,s);
  StrName:=s;
  for i:=4 to 10 do  { with information }
    readln(grfile);  { the first ten string }
  while  ( not EOF(grfile) ) and ( difanv < difmax )  do
    begin
      with  grelem  do
        begin // current elements
          readln(grfile,t,a,e,gi,gn,gp);
          if   e < 0.0  then   e:=-e;
          if  gi < 0.0  then  gi:=-gi;
          if  gn < 0.0  then  gn:=360.0+gn;
          if  gp < 0.0  then  gp:=360.0+gp;
          valelm[1]:=e;
          valelm[2]:=gp;
          valelm[3]:=gi;
          valelm[4]:=gn;
          valelm[5]:=a;
          valelm[6]:=0.0;
          valelm[7]:=t/365.25;
        end;
      for i:=1 to 7 do
        begin
          if  valmax[i] < valelm[i]  then  valmax[i]:=valelm[i];
          if  valmin[i] > valelm[i]  then  valmin[i]:=valelm[i];
        end;
      difanv:=valmax[7]-valmin[7];
    end;
  for i:=1 to 7 do
    valnul[i]:=(valmax[i]+valmin[i])/2; // the middle point
  difanv:=valmax[7]-valmin[7];
end;

end.
