unit UnLegFun ; { to make deal with Legandre polinoms after inclination }
interface       { with global numpol from untypvar }
{ to make deal with Legandre polinoms
  power by powers
  P_0(x) = 1
  P_1(x) = x
  P_2(x) = 3/2 * x^2 - 1/2
  ...
  P_n(x) = (2n-1)/n * x * P_(n-1) (x) - (n-1)/n * P_(n-2) (x) }
procedure ForLegFun ; { with global numpol from untypvar }
implementation
uses
  UnTypVar , { for variables mectmp rowtmp^ }
  UnRowMul , { to multiply AmpFactor for example }
  UnRowLow , { to change arrays }
  unwrtext ; { for procedure rowtotext }
procedure LegSimple ; { initial only unit to rowtmp }
begin
  mectmp:=1;          { only one simple terms equal 1 P_0(x) = 1 }
  rowtmp^[1]:=recnul; { intitial nullo }
  rowtmp^[1].amp[1]:=+1; { other elements are nullo from RowNullo UnRowIni }
end;
procedure LegAmpOne ( n  : Byte ) ; { -(n-1)/n * P_(n-2) (x) }
var                                 { P_(n-2)(x) in rowtmp }
  m  : Word ;
  a  : Extended ;
begin
  a:=n;           { from integer to float }
  a:=(1.0-a)/a;   { coefficient  -(n-1)/n }
  mectre:=mectmp; { from rowtmp to rowtre with factor -(n-1)/n }
  for m:=1 to mectre do
    begin                               { for all non-nullo records }
      rowtre^[m]:=rowtmp^[m];           { copy current record }
      AmpFactor(a,rowtre^[m].amp);      { to multiply amplitude by factor }
    end;
end;
procedure LegAmpTwo ( n  : Byte ) ; { to change rowtwo by factor }
var                                 { (2n-1)/n * P_(n-1)(x) }
  m  : Word ;
  a  : Extended ;
begin
  a:=n;           { from integer to float }
  a:=(2*a-1.0)/a; { coefficient  (2n-1)/n }
  mectmp:=mectwo; { number of terms for memory }
  for m:=1 to mectwo do
    begin                               { for all non-nullo records }
      rowtmp^[m]:=rowtwo^[m];           { to memory for the next step }
      AmpFactor(a,rowtwo^[m].amp);      { to multiply amplitude by factor }
    end;
end;
{ for  -[x/r*x'/r'+y/r*y'/r'+z/r*z'/r']
  there are meccoh terms in array rowcoh^ }
procedure ForLegFun ; { with global numpol from untypvar }
var
  npower  : Byte ;
begin
  maxsum:=numsum; { maximum power for giant planets untypvar }
  LegSimple ;     { initial only unit in rowtmp P_0(x) = 1 }
  npower:=1;      { P_1(x) = x in rowtre now }
  { for the order equal 1
    P_1(cos(H)) = cos(H) row in arrays rowtre^ and rowcoh^ }
  CosHtoTre ; { unrowlow from rowcoh^ to rowtre^ cos(H) }
  rowtotext(1,mectre,rowtre,'poleg0'); { unwrtext result }
  writeln('row for P_',npower,'(cos(H))',mectre:10,'  terms');
  while  npower < numpol  do { variables from UnTypVar }
    begin
      npower:=npower+1;  { the next power n }
      case  npower  of
        2  : maxsum:=numsum;
        3  : maxsum:=numsum div 2;
        else maxsum:=0;
      end; { case npower }
      LowerRow(2);       { UnRowLow rowtre to rowtwo P_(n-1) (x) }
      LegAmpOne(npower); { with rowtmp to rowtre -(n-1)/n * P_(n-2) (x) }
      LegAmpTwo(npower); { to rowtwo (2n-1)/n * P_(n-1)(x) to rowtmp }
      CosHtoOne ;        { UnIncIni cos(H) to rowone for x to multiply }
      MultForRow(1.0);   { UnRowMul rowtre + (2n-1)/n*x*P_(n-1)(x) }
      rowtotext(npower,mectre,rowtre,'poleg0');  { unwrtext result }
      writeln('row for P_',npower,'(cos(H))',mectre:10,'  terms');
    end;
end;
end.
