{ for the partial derivations
  with canonical elements L G H 
  numsel = 14 ;
  selected parameters:
  p=(1/sqrt(1-e^2)) , e , s , c ,
  p' , e' , s' , c' ,
  a , a' , r , r' , n , n'
  but prime for the giant planet
  without partial derivations
  TDimSel  = array[1..numsel] of ShortInt ;
  TMecDif  = array[1..3] of TDimSel ;
  medisa  : TMecDif ;  partial derivations of semimajor axis
  medipa  : TMecDif ;  partial derivations of (1/sqrt(1-e^2)
  medecc  : TMecDif ;  partial derivations of e with L G H
  mesini  : TMecDif ;  partial derivations of s=sin(i)
  mecosi  : TMecDif ;  partial derivations of c=cos(i)
  memoti  : TMecDif ;  partial derivations of n mean motion }
unit unpartif ; { for the partial derivations of parameters }
interface
procedure allparmdif ; { for the partial derivations with L G H }
implementation
uses
  untypvar ; { types constants }
procedure allparmini ; { initial nullo to arrays }
var
  i  : byte ;  { count for three elements L G H }
  j  : byte ;  { count for selected  parameters }
begin            { e eccentricity i inclination }
for i:=1 to 3 do { nullo to amplitudes }
  begin
    amplia[i]:=0.0;
    amplin[i]:=0.0;
    amplip[i]:=0.0;
    amplie[i]:=0.0;
    amplis[i]:=0.0;
    amplic[i]:=0.0;
  end;
for i:=1 to 3 do         { for three elements L G H }
  for j:=1 to numsel do  { global numsel from untypvar }
    begin                { for all parameters }
      medisa[i][j]:=0; { initial nullo a }
      memoti[i][j]:=0; { initial nullo n }
      medipa[i][j]:=0; { initial nullo 1/sqrt(1-e^2) }
      medecc[i][j]:=0; { initial nullo e }
      mesini[i][j]:=0; { initial nullo sin(i) }
      mecosi[i][j]:=0; { initial nullo cos(i) }
    end;
end;
{ legend for partial differentiation:
  L=sqrt(f*m*a)
  n^2*a^3=fm
  L=sqrt(f*m*a)=n*a^2
  G=L*sqrt(1-e^2)=n*a^2/p
  H=G*cos(i)=G*c
  a=L^2/(f*m)
  p=1/sqrt(1-e^2)=L/G
  e^2=1-G^2/L^2
  c=H/G
  s^2=1-H^2/G^2
  n=(f*m)^2/L^3
  da/dL=2*L/fm=2/(n*a)   ! factor +2
  dn/dL=-3/a^2           ! factor -3
  dp/dL=1/G=p/(n*a^2)
  dp/dG=-L/G^2=-p^2/(n*a^2)
  ds/dG=(1/s)*(H^2/G^3)=p*c^2/(s*n*a^2)
  ds/dH=-1/s*(H/G^2)=-p*c/(s*n*a^2)
  dc/dG=-H/G^2=-p*c/(n*a^2)
  dc/dH=1/G=p/(n*a^2)
  de/dL=((1-e^2)/e)*(1/L)=1/(p^2*e*n*a^2)
  de/dG=-(1/e)*(sqrt(1-e^2)/L)=-1/(p*e*n*a^2) }
procedure allparmdif ;
begin
  { parameters
    a - mec[9] p - mec[1] e - mec[2]
    s - mec[3] c - mec[4] n - mec[13] }
  allparmini ; { initial nullo to all derivations }
  { da/dL = 2 * (1/n) * (1/a) but factor 2 }
  amplia[1]:=+2.0;   { factor +2 }
  medisa[1][9]:=-1;  { 1/a }
  medisa[1][13]:=-1; { 1/n }
  { dn/dL=-3/a^2 factor -3 }
  amplin[1]:=-3.0;   { factor -3 }
  memoti[1][9]:=-2;  { 1/a^2 }
  { dp/dL=1/G=p/(n*a^2) }
  amplip[1]:=+1.0;   { factor +1 }
  medipa[1][1]:=+1;  { p }
  medipa[1][9]:=-2;  { 1/a^2 }
  medipa[1][13]:=-1; { 1/n }
  { dp/dG=-L/G^2=-p^2/(n*a^2) }
  amplip[2]:=-1.0;   { factor -1 }
  medipa[2][1]:=+1;  { p }
  medipa[2][9]:=-2;  { 1/a^2 }
  medipa[2][13]:=-1; { 1/n }
  { de/dL=((1-e^2)/e)*(1/L)=1/(p^2*e*n*a^2) }
  amplie[1]:=+1.0;   { factor +1 }
  medecc[1][1]:=+2;  { p^2 }
  medecc[1][2]:=-1;  { 1/e }
  medecc[1][9]:=-2;  { 1/a^2 }
  medecc[1][13]:=-1; { 1/n }
  { de/dG=-(1/e)*(sqrt(1-e^2)/L)=-1/(p*e*n*a^2) }
  amplie[2]:=-1.0;   { factor -1 }
  medecc[2][1]:=+1;  { p }
  medecc[2][2]:=-1;  { 1/e }
  medecc[2][9]:=-2;  { 1/a^2 }
  medecc[2][13]:=-1; { 1/n }
  { ds/dG=(1/s)*(H^2/G^3)=p*c^2/(s*n*a^2) }
  amplis[2]:=+1.0;   { factor +1 }
  mesini[2][1]:=+1;  { p }
  mesini[2][4]:=+2;  { c^2 }
  mesini[2][3]:=-1;  { 1/s }
  mesini[2][9]:=-2;  { 1/a^2 }
  mesini[2][13]:=-1; { 1/n }
  { ds/dH=-1/s*(H/G^2)=-p*c/(s*n*a^2) }
  amplis[3]:=-1.0;   { factor -1 }
  mesini[3][1]:=+1;  { p }
  mesini[3][4]:=+1;  { c }
  mesini[3][3]:=-1;  { 1/s }
  mesini[3][9]:=-2;  { 1/a^2 }
  mesini[3][13]:=-1; { 1/n }
  { dc/dG=-H/G^2=-p*c/(n*a^2) }
  amplic[2]:=-1.0;   { factor -1 }
  mecosi[2][1]:=+1;  { p }
  mecosi[2][4]:=+1;  { c }
  mecosi[2][9]:=-2;  { 1/a^2 }
  mecosi[2][13]:=-1; { 1/n }
  { dc/dH=1/G=p/(n*a^2) }
  amplic[3]:=+1.0;   { factor +1 }
  mecosi[3][1]:=+1;  { p }
  mecosi[3][9]:=-2;  { 1/a^2 }
  mecosi[3][13]:=-1; { 1/n }
end;
end.
