{ to obtain brackett [F_1,S_1] step bey step }
unit unparuso ; { for Pouassoun brackett }
interface
{ to differentiate function with respect to L G H }
procedure DifWithDelon ( n  : byte ;          { number of file }
                         s  : shortstring ) ; { part of the file name }
{ to differentiate function with respect to angle variables l g h }
procedure DifWithDelan ( n  : byte ;          { number of file }
                         s  : shortstring ) ; { part of the file name }
implementation
uses
  Windows  , { function GetTickCount }
  untypvar , { types global variables }
  unwrtext , { to read to write text file for result }
  unrowmul ; { procedure NextTerMem }
{ to differentiate one term
  with one parameter with L G H
  df/dL_i=Sum [(df/dp_j)*(dp_j/dL_i)]
  with similar terms to arrays rowone^(L) rowtwo^(G) rowtre^(H) }
procedure DifOneterlon ( k  : byte ;    { number for parameter }
                         a  : TAmpDif ; { [1..3] of extended for factor }
                         m  : TMecDif ; { [1..3] of TDimSel - [1..14] }
                         r  : TRowVar ) ; { current term }
var
  i  : byte ;    { count for variant L G H }
  j  : byte ;    { count for parameters }
  x  : TRowVar ; { current record }
  d  : array[1..3] of TRowVar ; { with L G H derivation }
begin
  maxsum:=numsum;        { for P_2 terms with planet elements }
  if  maxsum > 2  then  maxsum:=2; { to limit maximum power }
  if  ( ( r.mec[9] = 3 )
       and ( ( r.mec[6] <> 0 )
          or ( r.mec[7] <> 0 )
          or ( r.mec[8] <> 0 ) ) )
     then  exit ;
  if  r.mec[9] = 3  then  maxsum:=0;  { to limit number of terms }
  if  r.mec[9] > 3  then  exit ;
  if  r.mec[k] <> 0  then { power for current parameter }
    begin     { to differentiate with current parameter }
      x:=r; { current record for d/dp differentiation }
      x.amp[1]:=r.mec[k]*r.amp[1]; { derivation for amplitude }
      x.mec[k]:=r.mec[k]-1;        { derivation for power p }
      for i:=1 to 3 do { to differentiate with L G H }
        begin          { by dF_1/dp*dp/d(L,G,H) }
          d[i]:=x; { for partial derivation with L G H  to multiply }
          d[i].amp[1]:=a[i]*x.amp[1]; { by factor from dp_k/dL_i }
          for j:=1 to numsel do  { for all parameters powers }
            d[i].mec[j]:=x.mec[j]+m[i][j];
        end; { result for derivartion from one term }
      if  ( Abs(d[1].amp[1]) > 1.0e-10 )      { may be nullo }
        then  NextTerMem(d[1],mecone,rowone); { UnRowMul for dL }
      if  ( Abs(d[2].amp[1]) > 1.0e-10 )      { may be nullo }
        then  NextTerMem(d[2],mectwo,rowtwo); { UnRowMul for dG }
      if  ( Abs(d[3].amp[1]) > 1.0e-10 )      { may be nullo }
        then  NextTerMem(d[3],mectre,rowtre); { UnRowMul for dH }
    end;     { with respect to L G H is in records d[1] d[2] [3] }
end;
{ to differentiate function with respect to L G H }
procedure DifWithDelon ( n  : byte ;          { number of file }
                         s  : shortstring ) ; { part of the file name }
var
  m  : word ;        { count for terms }
  a  : longint ;     { current moment in millisecond }
  b  : longint ;     { current moment in millisecond }
begin                           { global variables UnTypVar }
  texttorow(n,s,meccoh,rowcoh); { our file to array rowcoh^ unwrtext }
  if  meccoh = 0  then Exit ;   { no terms no action }
  a:=GetTickCount ; { Windows current moment in millisecond }
  mecone:=0; { rowone^ for d/dL }
  mectwo:=0; { rowtwo^ for d/dG }
  mectre:=0; { rowtre^ for d/dH }
  m:=0; { initial nullo terms to read from array }
repeat  { for each term with similar result to row one^ two^ tre^ }
  m:=m+1;        { number for the next term  to differentiate }
  DifOneterlon(1,amplip,medipa,rowcoh^[m]);  { derivation parameter p }
  DifOneterlon(2,amplie,medecc,rowcoh^[m]);  { derivation parameter e }
  DifOneterlon(3,amplis,mesini,rowcoh^[m]);  { derivation parameter s }
  DifOneterlon(4,amplic,mecosi,rowcoh^[m]);  { derivation parameter c }
  DifOneterlon(9,amplia,medisa,rowcoh^[m]);  { derivation parameter a }
  DifOneterlon(13,amplin,memoti,rowcoh^[m]); { derivation parameter n }
  b:=GetTickCount ; { Windows current moment in millisecond }
  if  ( (b-a) > 10000 )  then
    begin
      a:=b;
      writeln(m:10,meccoh:10,'  :',mecone:10,mectwo:10,mectre:10);
    end;
until  ( m = meccoh ) ; { for all terms this operation }
  { to write result   three text files procedure unwrtext }
  rowtotext(11,mecone,rowone,s); { d/dL for this function }
  rowtotext(12,mectwo,rowtwo,s); { d/dG for this function }
  rowtotext(13,mectre,rowtre,s); { d/dH for this function }
  writeln(meccoh:10,'  d(',s,')/d(L,G,H) :',mecone:10,mectwo:10,mectre:10);
end;
{ to differentiate one term with l g h
  with similar terms to arrays rowone^(l) rowtwo^(g) rowtre^(h) }
procedure DifOneterlan ( r  : TRowVar ) ; { current term }
                         
var
  i  : byte ;    { count for variant l g h }
  x  : TRowVar ; { current record }
  d  : array[1..3] of TRowVar ; { with L G H derivation }
begin
  maxsum:=numsum;         { for P_2 terms with planet elements }
  if  maxsum > 2  then  maxsum:=2; { to limit maximum power }
  if  ( ( r.mec[9] = 3 )
       and ( ( r.mec[6] <> 0 )
          or ( r.mec[7] <> 0 )
          or ( r.mec[8] <> 0 ) ) )
     then  exit ;
  if  r.mec[9] = 3  then  maxsum:=0;  { to limit number of terms }
  if  r.mec[9] > 3  then  exit ;
  { with respect to l g h is in records d[1] d[2] [3] }
  for i:=1 to 3 do  { to differentiate with g h }
    begin
      d[i]:=recnul; { nullo default untypvar }
      if  r.mar[i+1] <> 0  then { current angle argument }
        begin     { to differentiate with current angle argument }
          x:=r; { current record for d/d(l,g) differentiation }
          x.amp[1]:=r.mar[i+1]*r.amp[1]; { derivation for amplitude }
          if  r.fcs = 'C'   { before cosinus }
            then            { after differentiation }
              begin         { our function is sinus }
                x.amp[1]:=-x.amp[1]; { to change signum }
                x.fcs:='S'; { d(cos(k*x))/dx=-k*sin(k*x) }
              end           { before sinus }
            else            { our function cosinus }
              x.fcs:='C';   { d(sin(k*x))/dx=+k*cos(k*x) }
          d[i]:=x; { for partial derivation with l g h }
        end; { result for derivartion from one term }
    end;
  if  ( Abs(d[1].amp[1]) > 1.0e-10 )      { may be nullo }
    then  NextTerMem(d[1],mecone,rowone); { UnRowMul for dL }
  if  ( Abs(d[2].amp[1]) > 1.0e-10 )      { may be nullo }
    then  NextTerMem(d[2],mectwo,rowtwo); { UnRowMul for dG }
  if  ( Abs(d[3].amp[1]) > 1.0e-10 )      { may be nullo }
    then  NextTerMem(d[3],mectre,rowtre); { UnRowMul for dH }
end;
{ to differentiate function with respect to angle variables l g h }
procedure DifWithDelan ( n  : byte ;          { number of file }
                         s  : shortstring ) ; { part of the file name }
var
  m  : word ;        { count for terms }
  a  : longint ;     { current moment in millisecond }
  b  : longint ;     { current moment in millisecond }
begin                           { global variables UnTypVar }
  texttorow(n,s,meccoh,rowcoh); { our file to array rowcoh^ unwrtext }
  if  meccoh = 0  then Exit ;   { no terms no action }
  a:=GetTickCount ; { Windows current moment in millisecond }
  mecone:=0; { rowone^ for d/dl }
  mectwo:=0; { rowtwo^ for d/dg }
  mectre:=0; { rowtre^ for d/dh }
  m:=0; { initial nullo terms to read from array }
repeat  { for each term with similar result to row one^ two^ tre^ }
  m:=m+1;        { number for the next term  to differentiate }
  DifOneterlan(rowcoh^[m]);  { derivation with angle elements l g h }
  b:=GetTickCount ; { Windows current moment in millisecond }
  if  ( (b-a) > 1000 )  then
    begin
      a:=b;
      writeln(m:10,meccoh:10,'  :',mecone:10,mectwo:10,mectre:10);
    end;
until  ( m = meccoh ) ; { for all terms this operation }
  { to write result   three text files procedure unwrtext }
  rowtotext(21,mecone,rowone,s); { d/dl for this function }
  rowtotext(22,mectwo,rowtwo,s); { d/dg for this function }
  rowtotext(23,mectre,rowtre,s); { d/dh for this function }
  writeln(meccoh:10,'  d(',s,')/d(l,g,h) :',mecone:10,mectwo:10,mectre:10);
end;
end.
