unit unrowcor ; { to correct our row with power of 1/sqrt(1-e^2) }
interface
uses
  untypvar ; { for types TRowPtr for example }
{ to analyse current record }
procedure powirec ( z  : TRowVar ; { current record }
                    var  m  : word ;  { count for terms }
                    var  r  : TRowPtr ) ; { row untypvar }
{ term by term to correct in dynamic array }
procedure rowcote ( var  m  : word ;      { number of terms }
                    var  r  : TRowPtr ) ; { in dynamic array }
implementation
uses
  UnRowMul ; { for procedures NextTerMem ForAmpnul }
{ to analyse current record }
procedure powirec ( z  : TRowVar ; { current record }
                    var  m  : word ;  { count for terms }
                    var  r  : TRowPtr ) ; { row untypvar }
var
  a  : TRowVar ; { temporary record }
begin
  if  ( z.mec[1] > -1 )  { not p^-1 p^-2 p^-3 p^-4 }
    then                 { other power p }
      begin             { for other power of p direct to array r^ }
        NextTerMem(z,m,r); { procedure from unrowmul direct to r^ }
        Exit ;          { for other power of p direct to array r^ }
      end;
  if  z.mec[1] = -1  then  { power for p=1/sqrt(1-e^2) }
    begin                  { p^-1=p^1*(1-e^2) }
      a:=z;         { to copy record }
      a.mec[1]:=+1; { for p - p^+1 instead p^-1 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      a:=z;                { just to copy }
      a.amp[1]:=-z.amp[1]; { -e^2 }
      a.mec[1]:=+1;  { for p - p^1 instead p^-1 }
      a.mec[2]:=z.mec[2]+2; { power for e with e^2 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      Exit ; { for p^(-1)=[sqrt(1-e^2)]^(1)=p*(1-e^2) }
    end;
  if  z.mec[1] = -2  then  { power for p=1/sqrt(1-e^2) }
    begin                  { p^-2=1-e^2 }
      a:=z;
      a.mec[1]:=0; { without p p^0 instead p^-2 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      a:=z;
      a.amp[1]:=-z.amp[1]; { -e^2 }
      a.mec[1]:=0; { without p p^0 instead p^-2 }
      a.mec[2]:=z.mec[2]+2; { power for e with e^2 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      Exit ; { for [sqrt(1-e^2)]^2=1-e^2 }
    end;
  if  z.mec[1] = -3  then  { power for p=1/sqrt(1-e^2) }
    begin                  { p^(-3)=p*(1-2*e^2+e^4) }
      a:=z;        { to copy term }
      a.mec[1]:=+1; { for p - p^1 instead p^-3 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      a:=z;         { to copy term }
      a.amp[1]:=-2.0*z.amp[1]; { -2*e^2 }
      a.mec[1]:=+1; { for p - p^1 instead p^-3 }
      a.mec[2]:=z.mec[2]+2; { power for e with e^2 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      a:=z;         { to copy term to change }
      a.mec[1]:=+1; { for p - p^1 instead p^-3 }
      a.mec[2]:=z.mec[2]+4; { power for e with e^4 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      Exit ; { for p^(-3)=[sqrt(1-e^2)]^3=p*(1-2*e^2+e^4) }
    end;
  if  z.mec[1] = -4  then  { power for p=1/sqrt(1-e^2) }
    begin                  { p^-4=1-2*e^2+e^4 }
      a:=z;
      a.mec[1]:=0; { without p p^0 instead p^-4 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      a:=z;
      a.amp[1]:=-2.0*z.amp[1]; { -2*e^2 }
      a.mec[1]:=0; { without p p^0 instead p^-4 }
      a.mec[2]:=z.mec[2]+2; { power for e with e^2 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      a:=z;
      a.mec[1]:=0; { without p p^0 instead p^-4 }
      a.mec[2]:=z.mec[2]+4; { power for e with e^4 }
      NextTerMem(a,m,r); { new term procedure from unrowmul }
      Exit ; { for [sqrt(1-e^2)]^4=1-2*e^2+e^4 }
    end;
end;
{ term by term to correct in dynamic array }
procedure rowcote ( var  m  : word ;      { number of terms }
                    var  r  : TRowPtr ) ; { in dynamic array }
var
  i  : shortint ; { simple count }
  k  : word ;     { count for terms }
  j  : word ;     { number of terms in }
  g  : TRowPtr ;  { temporary dynamic array }
  l  : word ;     { number of terms in }
  h  : TRowPtr ;  { temporary dynamic array }
begin
  writeln('to correct array with  ',m,'  terms');
  GetMem(g,SizeOf(TRowDim)); { temporary memory UnTypVar }
  GetMem(h,SizeOf(TRowDim)); { temporary memory UnTypVar }
  l:=0;       { initial nullo term in array h^ to sum terms }
  i:=-6;      { initial to select i*h }
repeat        { to select terms with argument i*h }
  j:=0;       { initial nullo terms in array g^ }
  for k:=1 to m do            { for all terms in array r^ }
    if  ( r^[k].mar[4] = i )  { this is our argument for angle h }
      then                    { the next term to analyse }
        powirec(r^[k],j,g);   { to keep in array g^[..] }
  ForAmpNul(j,g);         { in g^ may be nullo elements }
  for k:=1 to j do
    begin       { from array g^ to add to array h^ }
      l:=l+1;      { the next term by term }
      h^[l]:=g^[k]; { to copy term }
    end;
  writeln('to correct with power of p:',i:6,m:10,j:10,l:10);
  i:=i+1;
until  i > 6 ; { to select terms with argument i*h }
  { all number of terms is l in dynamic array h^ }
  m:=l;  { number of terms after correction }
  for k:=1 to l do  { for all terms }
    r^[k]:=h^[k];   { our array after correction }
  FreeMem(h,SizeOf(TRowDim)); { without temporary memory }
  FreeMem(g,SizeOf(TRowDim)); { without temporary memory }
end;
end.
