
{ to prognoz
  by using numerical integration method }

(*
type
  tsagelm = record { to identify the current satellite }
              mig   : byte ;     { number of the main planet }
              snm   : string[16] ; { may be the number of the satellite }
              stn   : string[16] ; { may be the name }
              epo   : double ;   { elements epoch in julian day }
              ela   : double ;   { semimajor axis in astronomical unit }
              ele   : double ;   { eccentricity }
              eli   : double ;   { inclination in degree }
              eln   : double ;   { longitude of ascension node in degree }
              elp   : double ;   { argument of perihelion in degree }
              elm   : double ;   { mean anomaly in degree }
            end;
*)

unit UnSagmun ;

interface

uses
  UnSagCoT ; { for type tastel record for elements }

{ to prognoz by integration orbit }

procedure SatGiamun ( mp  : integer ;   { number of step to print }
                      hd  : Extended ;  { step for integration }
                      ta  : Extended ;  { start  moment }
                      tb  : Extended ;  { finish moment }
                      el  : tsagelm ) ; { UnSagCoT type elements }

implementation

uses
  uneveras , { for EverGrator procedures EverInit EverCoefNullo }
  unforequ , { for procedure  toequars ecliptic elem to equapos }
  unforprt , { protocol text  file fprt }
  unforstr , { function FloatToSingle to convert numbers }
  unsagvar ; { global PlanetMain integer }

const
  mare  = 1017 ; { for temporary memory for elements }
var
  marc  : word ;  { count for temporary value }
  arel  : array[1..mare] of tsagelm ; { temporary memory }

{ from planetocentric
  equator descart to geoecliptic kepler elements }

procedure ToPrintOuresult ( t  : extended ;  r , v  : tvect3 );
var
  m  : word ;   { count for array }
  e  : tsagelm ; { for elements }
begin
  toeclipt(t,r,v,e); { unforequ procedure planetocentric }
  marc:=marc+1;      { count for array with elements }
  arel[marc]:=e;     { the next set of elements to memory }
  if  marc = mare    { array is full }
    then
      for m:=1 to marc do
        with  arel[m]  do
          writeln(fprt,epo:12:2,  { epoch of the elements }
                       ela:13:6,  { a semimajor axis AU }
                       ele:13:8,  { e eccentricity }
                       eli:13:5,  { i inclination in degree }
                       eln:13:5,  { O the ascending node degree }
                       elp:13:5); { o the argument of pericentre degree }
  if  marc = mare  then  marc:=0; { nullo value in memory }
end;

procedure ToScreenOuresult ( t  : extended ;  r , v  : tvect3 );
var
  e  : tsagelm ; { for elements }
begin
  toeclipt(t,r,v,e); { unforequ procedure planetocentric }
  with  e  do
    writeln((epo-jd2000)/365.25:12:5,    { epoch of the elements }
            ela:13:6,    { a semimajor axis AU }
            ele:13:8,    { e eccentricity }
            eli:13:5,    { i inclination in degree }
            eln:13:5,    { O the ascending node degree }
            elp:13:5);   { o the argument of pericentre degree }
end;

{ to prognoz by integration orbit }

procedure SatGiamun ( mp  : integer ;   { number of step to print }
                      hd  : Extended ;  { step for integration }
                      ta  : Extended ;  { start  moment }
                      tb  : Extended ;  { finish moment }
                      el  : tsagelm ) ;  { UnSagCoT type elements }
var
  me  : word ;            { simple count for elements in memory }
  np  : integer ;         { current number of step to integrate }
  tc  : extended ;        { current julian date }
  tp  : extended ;        { julian day to screen result }
  dt  : extended ;        { step in day to integrate }
  xc  : tvect3 ;          { type unastcot position }
  vc  : tvect3 ;          { type unastcot velosity }
  za  : extended ;        { small interval for integration start }
  zb  : extended ;        { small interval for integration finish }
  ra  : tvect3 ;          { small position for integration start }
  rb  : tvect3 ;          { small position for integration finish }
  va  : tvect3 ;          { small velosity for integration start }
  vb  : tvect3 ;          { small velosity for integration finish }

begin

  PlanetMain:=el.mig; { global from unsagvar }

  dt:=hd;     { this is a value of step in day to integrate }
              { in tc is epoch of the elements as start moment }
  tc:=el.epo; { this value may be greater than start moment ta }
                      { from elements ecliptic to equator }
  toequars(el,xc,vc); { unforequ position AU velosity AU/day }

  za:=tc; { start  moment to integrate }
  zb:=za; { finish moment to integrate initial equal start }

  ra:=xc; { start  position vector in interval to integrate }
  rb:=ra; { finish position vector in interval to integrate }

  va:=vc; { start  velosity vector in interval to integrate }
  vb:=va; { finish velosity vector in interval to integrate }

  EverInit ;       { unit ueveras to start PosVelEverGrator }
  EverCoefNullo ;  { unit ueveras to start PosVelEverGrator }

  if  za > ta                       { epoch of the elements }
    then                 { may be greater than start moment }
      while  za > ta  do         { backward to start moment }
        PosVelEverGrator(-dt,za,ra,va,zb,rb,vb)  { uneveras }
    else                 { or may be less than start moment }
      while  za < ta  do          { forward to start moment }
        PosVelEverGrator(+dt,za,ra,va,zb,rb,vb); { uneveras }

  za:=zb; { moment in julian day  forward }
  ra:=rb; { start position vector to integrate }
  va:=vb; { start velosity vector to integrate }

  tc:=za; { current moment to print result }

  tp:=tc;  { julian day to print result }
  np:=0;   { initial nullo to print result }
  marc:=0; { initial count for elements to memory }
  ToPrintOuresult(zb,rb,vb);
  ToScreenOuresult(zb,rb,vb);

  EverInit ;      { unit uneveras to start PosVelEverGrator }
  EverCoefNullo ; { unit uneveras to start PosVelEverGrator }

  while  tc < tb  do { from start to finish moment }
    begin            { step by step to binary file }

      PosVelEverGrator(dt,za,ra,va,zb,rb,vb);    { from unit uneveras }

      tc:=zb;   { the next moment }

      np:=np+1; { the next step to integrate }
      if  np = mp  then  { equal number of step to print }
        begin
          ToPrintOuresult(zb,rb,vb);
          np:=0;
        end;

      if  ( (tc-tp) > 36525.0 )  then
        begin
          ToScreenOuresult(zb,rb,vb);
          tp:=tc; { the next current moment to screen }
        end;

    end;

  if  marc > 0    { there are values in our array }
    then
      for me:=1 to marc do
        with  arel[me]  do
          writeln(fprt,epo:12:2,    { epoch of the elements }
                       ela:13:6,    { a semimajor axis AU }
                       ele:13:8,    { e eccentricity }
                       eli:13:5,    { i inclination in degree }
                       eln:13:5,    { O the ascending node degree }
                       elp:13:5);   { o the argument of pericentre degree }

end;

end.
