{ Kepler usual elements:
  positional  a e i angle \Omega \omega M
  canonical Delone elements  L G H l g=\omega+90 h=\Omega-90 }
unit UnSagOsc ; { from osculating to middle elements }
interface
uses
  untypvar , { types TRowPtr constants }
  unsagcot ; { type tsagelm tsagano tvarsix }
{ canonical elements L_i l_i without periodic terms }
procedure oscutomeone ( el  : tsagelm ;       { initial kepler elements }
                        mo  : word ;          { number of terms  in row }
                        ro  : trowptr ;       { dynamical array for row }
                        var  xo  : tsagano ;  { initial canonical elem. }
                        var  ys  : tvarsix ;  { periodic terms }
                        var  xp  : tsagano ;  { middlecanonical elements }
                        var  ep  : tsagelm ) ; { usual elements but middle }
{ from secular canonical elements to
  canonical elements L_i l_i with periodic terms }
procedure secularoscu ( mo  : word ;     { number of terms  in row }
                        ro  : trowptr ;  { dynamical array for row }
                        xo  : tsagano ;  { secular canonical elem. }
                        var  ys  : tvarsix ;   { periodic terms to add }
                        var  xp  : tsagano ; { to canonical elements }
                        var  ep  : tsagelm ) ; { usual elements but middle }
implementation
uses
  untheors , { for procedure withoushort }
  unsagelm ; { procedures togetoscano togecanoscu }
{ canonical elements L_i l_i without periodic terms
  generating function S_1 from text file prefos1.txt is in rowone^[..]
  generating function~S_1 from text file pregos1.txt is in rowfur^[..]
  generating function~S_2 from text file pregos3.txt is in rowfiv^[..] }
procedure oscutomeone ( el  : tsagelm ;       { initial kepler elements }
                        mo  : word ;          { number of terms  in row }
                        ro  : trowptr ;       { dynamical array for row }
                        var  xo  : tsagano ;  { initial canonical elem. }
                        var  ys  : tvarsix ;  { periodic terms }
                        var  xp  : tsagano ;  { middle canonical elements }
                        var  ep  : tsagelm ) ; { usual elements but middle }
begin
  ep:=el; { default only for name and number of the object }
  { from  usual Kepler to canonical Delone elements }
  togetoscano(el,xo); { from unsagelm to canonical }
  tomorelong(xo,mo,ro,ys,xp); { from untheors minus periodic terms }
  { to change from Delone to Kepler elements }
  togecanoscu(xp,ep); { from unsagelm to Keplerian but middle }
end;
{ from secular canonical elements to
  canonical elements L_i l_i with periodic terms }
procedure secularoscu ( mo  : word ;     { number of terms  in row }
                        ro  : trowptr ;  { dynamical array for row }
                        xo  : tsagano ;  { secular canonical elem. }
                        var  ys  : tvarsix ; { periodic terms to add }
                        var  xp  : tsagano ; { to canonical elements }
                        var  ep  : tsagelm ) ; { usual elements but middle }
begin
  tomoreshot(xo,mo,ro,ys,xp); { from untheors minus periodic terms }
  { to compare elements may be L < G or G < H }
  if  ( ( xp.e[1] < xp.e[2] ) or ( xp.e[2] < Abs(xp.e[3]) ) )
    then  xp:=xo; { osculating elements is bad }
  { to change from Delone to Kepler elements }
  togecanoscu(xp,ep); { from unsagelm to Keplerian but middle }
end;
end.
