
{ to find satellite
  of the giant planet from text file outsat.txt }

unit UnSagReF ; { to read text file outsat.txt }

interface

uses
  UnSagCoT ; { for type tastel }

{ input   n number of object in text file
  output  e set of kepler elements of the object
  to find one satellite from text file outsat.txt }

procedure OneSagWithList ( n  : Integer ;  var  e  : tsagelm ) ;

{ input   s name or part of name of object 
  output  e set of kepler elements of the object
  to find one satellite from text file outsat.txt }

procedure OneSagWithName ( s  : string ;  var  e  : tsagelm ) ;

implementation

{ input   n number of object in text file
  output  e set of kepler elements of the object
  to find one satellite from text file outsat.txt }

procedure OneSagWithList ( n  : Integer ;  var  e  : tsagelm ) ;
var
  i  : Integer ; { simple count }
  f  : Text ;    { file to read }
  b  : Boolean ;
begin
  assign(f,'outsat.txt'); { text file with the elements }
  reset(f);               { to open to read }
  b:=False;               { initial no object }
repeat
  readln(f,i);     { current number in list } 
  readln(f,e.mig); { number of the main planet }
  readln(f,e.snm); { may be the number of the asteroid string[16] }
  readln(f,e.stn); { may be the name string[16] }
  readln(f,e.epo); { elements epoch in julian day }
  readln(f,e.ela); { semimajor axis in astronomical unit }
  readln(f,e.ele); { eccentricity }
  readln(f,e.eli); { inclination in degree }
  readln(f,e.eln); { longitude of ascension node in degree }
  readln(f,e.elp); { argument of pericentre in degree }
  readln(f,e.elm); { mean anomaly in degree }
  if  i = n        { to compare numbers }
    then  b:=True; { this is our object }
until  b or EOF(f) ;      { may by end of file }
  close(f);               { that is all }
end;

{ input   s name or part of name of object
  output  e set of kepler elements of the object
  to find one satellite from text file outsat.txt }

procedure OneSagWithName ( s  : string ;  var  e  : tsagelm ) ;
var
  f  : Text ;    { file to read }
  b  : Boolean ;
begin
  assign(f,'outsat.txt'); { text file with the elements }
  reset(f);               { to open to read }
  b:=False;               { initial no object }
repeat
  readln(f);     { current number in list }
  readln(f,e.mig); { number of the main planet }
  readln(f,e.snm); { may be the number of the asteroid string[16] }
  readln(f,e.stn); { may be the name string[16] }
  readln(f,e.epo); { elements epoch in julian day }
  readln(f,e.ela); { semimajor axis in astronomical unit }
  readln(f,e.ele); { eccentricity }
  readln(f,e.eli); { inclination in degree }
  readln(f,e.eln); { longitude of ascension node in degree }
  readln(f,e.elp); { argument of perihelii in degree }
  readln(f,e.elm); { mean anomaly in degree }
                        { to compare names in strings }
  if  Pos(s,e.stn) > 0  { may be our name }
    then                { after compare }
      b:=True; { this is our object }
until  b or EOF(f) ;      { may by end of file }
  close(f);               { that is all }
end;

end.
