unit unsecosc ; { to change between osculating }
interface       { and secular elements by using corelem }
uses
  unsagcot , { types const jd2000 }
  untypvar ; { types gloabl variables }
{ current set of the elements to screen }
procedure ToScreenOuresult ( e  : tsagelm ); { for elements }
{ from kepler osculating
  to secular canonical and kepler elements }
procedure frocusec ( el  : tsagelm ;      { osculating elements unsagcot }
                     var  xp  : tsagano ;   { secular canonical unsagcot }
                     var  es  : tsagelm ) ; { secular kepler elements }
{ from secular canonical to osculating kepler elements }
procedure frosecos ( xp  : tsagano ; { secular canonical unsagcot }
                     var  ex  : tsagelm ;   { middle kepler elements }
                     var  es  : tsagelm ) ; { oscula kepler elements }
implementation
uses
  unsagosc ; { procedure oscutomeone }
{ current set of the elements to screen }
procedure ToScreenOuresult ( e  : tsagelm ); { for elements }
begin
  with  e  do
    writeln(((epo-jd2000)/365.25):12:5, { time in year }
            ela:13:6,    { a semimajor axis AU }
            ele:13:8,    { e eccentricity }
            eli:13:5,    { i inclination in degree }
            eln:13:5,    { O the ascending node degree }
            elp:13:5);   { o the argument of pericentre degree }
end;
{ from kepler osculating
  to secular canonical and kepler elements }
procedure frocusec ( el  : tsagelm ;      { osculating elements unsagcot }
                     var  xp  : tsagano ;   { secular canonical unsagcot }
                     var  es  : tsagelm ) ; { secular kepler elements }
var
  ep  : tsagelm ; { temporary set of Kepler elements }
  ex  : tsagelm ; { temporary set of Kepler elements }
  xo  : tsagano ; { temporary set of canonical elements }
  xq  : tsagano ; { temporary set of canonical elements }
  ys  : tvarsix ; { partial derivations dS/d(l g h L G H }
begin
  { unsagosc L'_i l'_i without short p.t. file  prefos1.txt }
  oscutomeone(el,mecone,rowone,xo,ys,xq,ep); { global untypvar }
  { unsagosc ~L_i ~l_i without long p.t.  file  pregos1.txt }
  oscutomeone(ep,mecfur,rowfur,xo,ys,xq,ex); { global untypvar }
  { unsagosc ~L_i ~l_i without long p.t.  file  pregos3.txt }
  oscutomeone(ex,mecfiv,rowfiv,xo,ys,xp,es); { global untypvar }
end;
{ from secular canonical to osculating kepler elements }
procedure frosecos ( xp  : tsagano ; { secular canonical unsagcot }
                     var  ex  : tsagelm ;   { middle kepler elements }
                     var  es  : tsagelm ) ; { oscula kepler elements }
var
  ep  : tsagelm ; { temporary set of Kepler elements }
  xo  : tsagano ; { temporary set of canonical elements }
  xq  : tsagano ; { temporary set of canonical elements }
  ys  : tvarsix ; { partial derivations dS/d(l g h L G H }
begin
  { unsagosc L'_i ~l'_i with long p.t.  file  pregos3.txt }
  secularoscu(mecfiv,rowfiv,xp,ys,xo,ep); { global untypvar }
  { unsagosc L'_i ~l'_i with long p.t.  file  pregos1.txt }
  secularoscu(mecfur,rowfur,xo,ys,xq,ex); { global untypvar }
  { unsagosc L_i l_i with short p.t. file  prefos1.txt }
  secularoscu(mecone,rowone,xq,ys,xo,es); { global untypvar }
end;
end.
