unit Unsequgr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls;

type
  TfmThous = class(TForm)
    mmMenuGr: TMainMenu;
    miPlanetC: TMenuItem;
    miExit: TMenuItem;
    FileBmpSaveDialog: TSaveDialog;
    odTextFile: TOpenDialog;
    miYear: TMenuItem;
    miYone: TMenuItem;
    miYtwo: TMenuItem;
    miYtre: TMenuItem;
    miYfur: TMenuItem;
    miSaveBmp: TMenuItem;
    procedure miExitClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mmMenuGrChange(Sender: TObject; Source: TMenuItem;
      Rebuild: Boolean);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure miYoneClick(Sender: TObject);
    procedure miYtwoClick(Sender: TObject);
    procedure miYtreClick(Sender: TObject);
    procedure miYfurClick(Sender: TObject);
    procedure miPlanetCClick(Sender: TObject);
    procedure miSaveBmpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmThous: TfmThous;

implementation

uses
  unitseqt , // for difmax for example
  unitseqs , // for StrName  ShortString pb1,pb2,pb3,pb4
  unsecbim ; // for OneTryBitMap with SaveDialog

{$R *.DFM}

var
  booresize  : Boolean ; { only for the creation form }

procedure TfmThous.miExitClick(Sender: TObject);
begin
  Close ;
  filemode:=2;
end;

procedure TfmThous.FormResize(Sender: TObject);
var
  h,w  : Integer ;
begin
  h:=(fmThous.ClientHeight-20) div 3;
  w:=(fmThous.ClientWidth-25) div 2;
  with  pb1  do
    begin
      x1:=10;
      y1:=10;
      x2:=x1+w;
      y2:=y1+h;
    end;
  with  pb2  do
    begin
      x1:=10;
      y1:=10+h;
      x2:=x1+w;
      y2:=y1+h;
    end;
  with  pb3  do
    begin
      x1:=10;
      y1:=10+2*h;
      x2:=x1+w;
      y2:=y1+h;
    end;
  with  pb4  do
    begin
      x1:=10+w+5;
      y1:=10;
      x2:=x1+w;
      y2:=y1+h;
    end;
  with  pb5  do
    begin
      x1:=10+w+5;
      y1:=10+h;
      x2:=x1+w;
      y2:=y1+h;
    end;
  with  pb6  do
    begin
      x1:=10+w+5;
      y1:=10+2*h;
      x2:=x1+w;
      y2:=y1+h;
    end;
  with  fmThous.Canvas  do
    begin
      Brush.Color:=clGreen;
      Rectangle(0,0,Width,Height);
      Brush.Color:=clYellow;
      Pen.Color:=clWhite;
      Rectangle(5,5,ClientWidth-5,ClientHeight-5);
      Brush.Color:=clWhite;
      Rectangle(pb1.x1,pb1.y1,pb1.x2,pb1.y2);
      Rectangle(pb2.x1,pb2.y1,pb2.x2,pb2.y2);
      Rectangle(pb3.x1,pb3.y1,pb3.x2,pb3.y2);
      Rectangle(pb4.x1,pb4.y1,pb4.x2,pb4.y2);
      Rectangle(pb5.x1,pb5.y1,pb5.x2,pb5.y2);
      Rectangle(pb6.x1,pb6.y1,pb6.x2,pb6.y2);
    end;
  fmThous.Canvas.Pen.Color:=clBlack;
  ForElemGraQ ; // from UnitSeqs
  ForElemGraS ; // from UnitSeqs
end;

procedure TfmThous.FormPaint(Sender: TObject);
begin
  if  not booresize  then  Exit ; { only for the creation form }
  with  fmThous.Canvas  do
    begin
      Brush.Color:=clGreen;
      Rectangle(0,0,Width,Height);
      Brush.Color:=clYellow;
      Pen.Color:=clWhite;
      Rectangle(5,5,ClientWidth-5,ClientHeight-5);
      Brush.Color:=clWhite;
      Rectangle(pb1.x1,pb1.y1,pb1.x2,pb1.y2);
      Rectangle(pb2.x1,pb2.y1,pb2.x2,pb2.y2);
      Rectangle(pb3.x1,pb3.y1,pb3.x2,pb3.y2);
      Rectangle(pb4.x1,pb4.y1,pb4.x2,pb4.y2);
      Rectangle(pb5.x1,pb5.y1,pb5.x2,pb5.y2);
      Rectangle(pb6.x1,pb6.y1,pb6.x2,pb6.y2);
    end;
  fmThous.Canvas.Pen.Color:=clBlack;
  ForElemGraQ ; // from UnitSeqs
  ForElemGraS ; // from UnitSeqs
  booresize:=True;
end;

procedure TfmThous.FormCreate(Sender: TObject);
begin
  filemode:=0;
  boocomp:=False; { usual case no compare }
  booaxis:=False; { usual case no planets axis }
  difmax:=10000; // interval in year
  StrFile:='s02_n_02.txt';
  booresize:=False;
  odTextFile.InitialDir:=GetCurrentDir; { SysUtils }
end;

procedure TfmThous.mmMenuGrChange(Sender: TObject; Source: TMenuItem;
  Rebuild: Boolean);
begin
  booresize:=True;
end;

procedure TfmThous.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if  ( y < pb1.y1 ) or ( y > pb3.y2 )  then  Exit;
  if  ( ( pb1.x1 < x ) and ( x < pb1.x2 ) )
       and ( ( pb1.y1 < y) and ( y < pb1.y2 ) )
    then  // from unit UnSecBim
      OneTryBitMap(pb1.x1,pb1.y1,pb1.x2,pb1.y2);
  if  ( ( pb2.x1 < x ) and ( x < pb2.x2 ) )
       and ( ( pb2.y1 < y) and ( y < pb2.y2 ) )
    then  // from unit UnSecBim
      OneTryBitMap(pb2.x1,pb2.y1,pb2.x2,pb2.y2);
  if  ( ( pb3.x1 < x ) and ( x < pb3.x2 ) )
       and ( ( pb3.y1 < y) and ( y < pb3.y2 ) )
    then  // from unit UnSecBim
      OneTryBitMap(pb3.x1,pb3.y1,pb3.x2,pb3.y2);
  if  ( ( pb4.x1 < x ) and ( x < pb4.x2 ) )
       and ( ( pb4.y1 < y) and ( y < pb4.y2 ) )
    then  // from unit UnSecBim
      OneTryBitMap(pb4.x1,pb4.y1,pb4.x2,pb4.y2);
  if  ( ( pb5.x1 < x ) and ( x < pb5.x2 ) )
       and ( ( pb5.y1 < y) and ( y < pb5.y2 ) )
    then  // from unit UnSecBim
      OneTryBitMap(pb5.x1,pb5.y1,pb5.x2,pb5.y2);
  if  ( ( pb6.x1 < x ) and ( x < pb6.x2 ) )
       and ( ( pb6.y1 < y) and ( y < pb6.y2 ) )
    then  // from unit UnSecBim
      OneTryBitMap(pb6.x1,pb6.y1,pb6.x2,pb6.y2);
  booresize:=true;
  fmThous.FormPaint(Sender);
end;

procedure TfmThous.miYoneClick(Sender: TObject);
begin
  difmax:=1000; // interval in year
  fmThous.FormPaint(Sender);
end;

procedure TfmThous.miYtwoClick(Sender: TObject);
begin
  difmax:=5000; // interval in year
  fmThous.FormPaint(Sender);
end;

procedure TfmThous.miYtreClick(Sender: TObject);
begin
  difmax:=10000; // interval in year
  fmThous.FormPaint(Sender);
end;

procedure TfmThous.miYfurClick(Sender: TObject);
begin
  difmax:=20000; // interval in year
  fmThous.FormPaint(Sender);
end;

procedure TfmThous.miPlanetCClick(Sender: TObject);
begin
  booresize:=True;
  booaxis:=False; { usual case no planets axis }
  if  fmThous.odTextFile.Execute  then
    begin
      StrFile:=fmThous.odTextFile.FileName;
      fmThous.FormPaint(Sender);
    end;
end;

procedure TfmThous.miSaveBmpClick(Sender: TObject);
begin
  with  fmThous do { to save BitMap diagram }
    OneTryBitMap(5,5,ClientWidth-5,ClientHeight-5);
  booresize:=true;
end;

end.
