
 UNIT UnStrDat ; { to change date between civil and julian forms }
                 { to change result from degree to civil strings }
 INTERFACE

 { from from date in julian day
     to string with date in civil form yyyy mm dd hh mm ss.s }

 function ToGetStrForDate ( it  : Byte ;  dt  : Extended ) : String ;

 { StrDegrA is quite simple function
   to change a value for  Angle  in degree
      to the civil form : Sign Degree Minute Second . }

 function StrDegrA ( i  : Byte ; Angle : Extended ) : String ;

 { StrHourA is quite simple function
   to change a value for  Angle  in degree
      to the civil form : Sign Hour Minute Second . }

 function StrHourA ( Angle : Extended ) : String ;

 IMPLEMENTATION

 uses
   UnForDat , { for TransJDtodate FromSecPartToHourMinSec }
   UnForStr ; { for function IntegerToFixStr }

 { from from date in julian day
     to string with date in civil form yyyy mm dd hh mm ss.s }

 function ToGetStrForDate ( it  : Byte ;  dt  : Extended ) : String ;
 var                      { byte it for digit after point }
   nd,nm,ny  : Integer ;
   kh,km  : Integer ;
   sp,az  : Extended ;
   st  : String ;
 begin
   TransJDtoDate(dt,nd,nm,ny,sp);        { UnForDat part of day in second }
   FromSecPartToHourMinSec(sp,kh,km,az); { UnForDat part to hour min seco }
   st:=IntegerToFixStr(ny,4)+' '+IntegerToFixStr(nm,2)
      +' '+IntegerToFixStr(nd,2)+'  ';
   st:=st+IntegerToFixStr(kh,2)+' '+IntegerToFixStr(km,2)
      +' '+FloatToFixStr(az,3+it,it); { byte it for digit after point }
   ToGetStrForDate:=st;
 end;

 { StrDegrA is quite simple function
   to change a value for  Angle  in degree
      to the civil form : Sign Degree Minute Second . }

 function StrDegrA ( i  : Byte ; Angle : Extended ) : String ;
 Var
   IntDeg  : Integer ;
   IntMin  : Integer;
   r,AngS  : Extended ;
   strcur  : String ;
 Begin
    r:=Abs(Angle);    { in degree }
    IntDeg:=Trunc(r);
    r:=60*Frac(r);
    IntMin:=Trunc(r);
    AngS:=60*Frac(r);
    if  AngS > 59.999 then begin AngS:=0; IntMin:=IntMin+1; end;
    if  IntMin > 59 then
      begin IntMin:=IntMin-60; IntDeg:=IntDeg+1; end;
    if  Angle < 0  then  strcur:=' -'                { negative value }
                   else  strcur:=' +';               { positive value }
    StrDegrA:=strcur+IntegerToFixStr(IntDeg,i)+' '    { UnForStr funct }
                    +IntegerToFixStr(IntMin,2)+' '    { UnForStr funct }
                    +FloatToFixStr(AngS,4,1);         { UnForStr funct }
 End;

 { StrHourA is quite simple function
   to change a value for  Angle  in degree
      to the civil form : Sign Hour Minute Second . }

 function StrHourA ( Angle : Extended ) : String ;
 Var
   IntHor  : Integer ;
   IntMin  : Integer;
   r,AngS  : Extended ;
   strcur  : String ;
 Begin
    r:=Abs(Angle)/15.0; { to hour min sec }
    IntHor:=Trunc(r);
    r:=60*Frac(r);
    IntMin:=Trunc(r);
    AngS:=60*Frac(r);
    if  AngS > 59.999 then begin AngS:=0; IntMin:=IntMin+1; end;
    if  IntMin > 59 then
      begin IntMin:=IntMin-60; IntHor:=IntHor+1; end;
    if  Angle < 0  then  strcur:=' -'  else  strcur:=' +';
    StrHourA:=strcur+IntegerToFixStr(IntHor,2)+' '
                    +IntegerToFixStr(IntMin,2)+' '
                    +FloatToFixStr(AngS,5,2);
 End;

 END.
