(*
  a=L^2/(f*m)
  p=1/sqrt(1-e^2)=L/G
  e^2=1-G^2/L^2
  c=H/G
  s^2=1-H^2/G^2
  n=(f*m)^2/L^3
  E-e*sin(E)=l
*)
unit unthelep ;
interface
uses
  unsagcot ; { type TVarSix }
{ our parameters  p e s c a n
  numerical values to global array  parall[1..numsel] }
procedure simparamon ( e  : tvarsix ) ; 
{ our argument v E g h to array argall }
procedure simargumon ( e  : tvarsix ) ;
implementation
uses
  untypvar , { global arrasy parall argall }
  ungiamod , { global PlanetFMain instead of fm fo giant planet }
  unforkep ; { function KeplerEquation for E in radian }
{ our parameters  p e s c a n
  numerical values to global array  parall[1..numsel] }
procedure simparamon ( e  : tvarsix ) ;
var
  i  : byte ; { simple count }
begin                   { global untypvar }
  for i:=1 to numsel do { for all parameters }
    parall[i]:=0.0;     { default nullo values }
  parall[1]:=e[1]/e[2];                   { p=1/sqrt(1-e^2)=L/G }
  parall[2]:=sqrt(1.0-sqr(e[2]/e[1]));    { e^2=1-G^2/L^2 }
  parall[3]:=sqrt(1.0-sqr(e[3]/e[2]));    { s^2=1-H^2/G^2 s=sin(i) }
  parall[4]:=e[3]/e[2];                   { c=H/G c=cos(i) may be negative }
  parall[9]:=sqr(e[1])/PlanetFMain;       { ungiamod a=L^2/(fm) }
  parall[13]:=sqr(PlanetFMain/e[1])/e[1]; { n=(fm)^2/L^3 }
  for i:=1 to 3 do                        { for L G H to use }
    begin                                 { derivations global untypvar }
      amplip[i]:=amplip[i]/parall[1];     { (1/p)*d(p)/d(L G H) }
      amplie[i]:=amplie[i]/parall[2];     { (1/e)*d(e)/d(L G H) }
      amplis[i]:=amplis[i]/parall[3];     { (1/s)*d(s)/d(L G H) }
      amplic[i]:=amplic[i]/parall[4];     { (1/c)*d(c)/d(L G H) }
      amplia[i]:=amplia[i]/parall[9];     { (1/a)*d(a)/d(L G H) }
      amplin[i]:=amplin[i]/parall[13];    { (1/n)*d(n)/d(L G H) }
    end;
end;
{ our argument v E g h to array argall }
procedure simargumon ( e  : tvarsix ) ;
var           { but without value for angle v }
  i  : byte ; { simple count }
begin                   { global untypvar }
  for i:=1 to maxarg do { for all arguments }
    argall[i]:=0.0;     { default nullo values  E-e*sin(E)=l }
  argall[2]:=KeplerEquation(parall[2],e[4]); { unforkep E in radian }
  argall[3]:=e[5]; { angle g numerical value }
  argall[4]:=e[6]; { angle h numerical value }
end;
end.
