unit untheors ; { for short periodic terms }
interface       { with S_1 prefos1.txt mecone terms in rowone^[..] }
uses
  unsagcot , { for types tsagano tvarsix }
  untypvar ; { for types trowptr trowvar }
{ initial nullo to correct canonical elements }
procedure difequnul ( var  q  : tvarsix ) ;     { unsagcot }
{ to obtain periodic terms
  to obtain values of the elements
  canonical without periodic terms }
procedure tomorelong ( xo  : tsagano ;     { L G H l g h current }
                       mo  : word ;        { number of terms  in row }
                       ro  : trowptr ;     { dynamical array for row }
                       var  ys  : tvarsix ;    { periodic terms }
                       var  xp  : tsagano ) ;  { L G H l g h more long }
{ to obtain values
  of the elements canonical with periodic terms }
procedure tomoreshot ( xo  : tsagano ;     { L G H l g h current }
                       mo  : word ;        { number of terms  in row }
                       ro  : trowptr ;     { dynamical array for row }
                       var  ys  : tvarsix ;    { periodic terms }
                       var  xp  : tsagano ) ;  { L G H l g h more short }
implementation
uses
  unthelem ; { procedure corelem }
{ initial nullo to correct canonical elements }
procedure difequnul ( var  q  : tvarsix ) ;     { unsagcot }
var
  i  : byte ; { simple count for elements in array }
begin
  for i:=1 to 6 do  q[i]:=0.0; { initial nullo corrections }
end;
{ to obtain periodic terms
  to obtain values of the elements
  canonical without periodic terms }
procedure tomorelong ( xo  : tsagano ;     { L G H l g h current }
                       mo  : word ;        { number of terms  in row }
                       ro  : trowptr ;     { dynamical array for row }
                       var  ys  : tvarsix ;    { periodic terms }
                       var  xp  : tsagano ) ;  { L G H l g h more long }
begin
  xp:=xo; { initial equal for moment }
  difequnul(ys); { initial nullo to array [1..6] }
  if  mo = 0  then  Exit ; { without action }
  corelem(xo,mo,ro,ys); { unthelem corrections to canonical }
  xp.e[1]:=xo.e[1]-ys[1]; { L'=L-dS/dl }
  xp.e[2]:=xo.e[2]-ys[2]; { G'=G-dS/dl }
  xp.e[3]:=xo.e[3]-ys[3]; { H'=H-dS/dl }
  xp.e[4]:=xo.e[4]+ys[4]; { l'=l+dS/dL }
  xp.e[5]:=xo.e[5]+ys[5]; { g'=g+dS/dG }
  xp.e[6]:=xo.e[6]+ys[6]; { h'=h+dS/dH }
end;
{ to obtain values
  of the elements canonical with periodic terms }
procedure tomoreshot ( xo  : tsagano ;     { L G H l g h current }
                       mo  : word ;        { number of terms  in row }
                       ro  : trowptr ;     { dynamical array for row }
                       var  ys  : tvarsix ;    { periodic terms }
                       var  xp  : tsagano ) ;  { L G H l g h more short }
begin
  xp:=xo; { initial equal for moment }
  difequnul(ys); { initial nullo to array [1..6] }
  if  mo = 0  then  Exit ; { without action }
  corelem(xo,mo,ro,ys); { unthelem corrections to canonical }
  xp.e[1]:=xo.e[1]+ys[1]; { L=L'+dS/dl' }
  xp.e[2]:=xo.e[2]+ys[2]; { G=G'dS/dl' }
  xp.e[3]:=xo.e[3]+ys[3]; { H=H'+dS/dl' }
  xp.e[4]:=xo.e[4]-ys[4]; { l=l'-dS/dL' }
  xp.e[5]:=xo.e[5]-ys[5]; { g=g'-dS/dG' }
  xp.e[6]:=xo.e[6]-ys[6]; { h=h'-dS/dH' }
end;
end.

