unit unwrtext ; { to write result rows in text format }
interface
uses
  untypvar ; { for types global variables }
{ to write result to text file }
procedure rowtotext ( n  : byte ;    { number of file }
                      m  : word ;    { number of terms }
                      r  : TRowPtr ; { our row to text type untypvar }
                      s  : shortstring ) ; { part of the name of the file }
{ to read result from text file }
procedure texttorow ( n  : byte ;           { number of file }
                      s  : shortstring ;    { part of the name of the file }
                      var  m  : word ;      { number of terms }
                      var  r  : TRowPtr ) ; { our row to text type untypvar }
implementation
uses
  SysUtils ; { function IntToStr }
{ to write result }
procedure rowtotext ( n  : byte ;    { number of file }
                      m  : word ;    { number of terms }
                      r  : TRowPtr ; { our row to text type untypvar }
                      s  : shortstring ) ; { part of the name of the file }
var
  f  : textfile ; { our text file to write result }
  i  : byte ; { count for power and arguments }
  k  : word ; { simple count for terms }
  z  : shortstring ; { full name of the text file }
begin
  z:=s+IntToStr(n)+'.txt'; { full name of the file }
  assignfile(f,z); { our text file with name }
  rewrite(f);      { to open our text file to write }
  writeln(f,m:10,'  terms in file .',z,'.');
  write(f,' ':19);
  write(f,'p':4,'e':4,'s':4,'c':4,
          'p''':5,'e''':4,'s''':4,'1-c''':5,
          'a':2,'a''':5,'r':3,'r''':5,'n':3,'n''':5);
  write(f,'v':4,'E':4,'g':4,'h':4,'v''':5,'E''':4,'g''':4,'h''':4);
  writeln(f,' f');
  for k:=1 to m do
    with  r^[k]  do
      begin
        write(f,amp[1]:18:12); { amplitude value }
        write(f,' ');
        for i:=1 to numsel do  { for power }
          write(f,mec[i]:4);   { all power value }
        write(f,' ');
        for i:=1 to maxarg do  { for arguments }
          write(f,mar[i]:4);   { all arguments value }
        write(f,'  ',fcs);     { function Co or Sinus }
        writeln(f,k:6);        { current number }
      end;
  closefile(f);    { that is all for this file }
end;
{ to read result from text file }
procedure texttorow ( n  : byte ;           { number of file }
                      s  : shortstring ;    { part of the name of the file }
                      var  m  : word ;      { number of terms }
                      var  r  : TRowPtr ) ; { our row to text type untypvar }
var
  f  : textfile ; { our text file to write result }
  i  : byte ; { count for power and arguments }
  k  : word ; { simple count for terms }
  b  : string[2] ;   { temporary to read two blanks }
  z  : shortstring ; { full name of the text file }
begin
  z:=s+IntToStr(n)+'.txt'; { full name of the file }
  assignfile(f,z); { our text file with name }
  reset(f);        { to open our text file to read }
  readln(f,m);     { number of terms in file }
  readln(f);       { simple string with title }
  for k:=1 to m do
    with  r^[k]  do
      begin
        read(f,amp[1]);        { amplitude value }
        for i:=1 to numsel do  { for power }
          read(f,mec[i]);      { all power value }
        for i:=1 to maxarg do  { for arguments }
          read(f,mar[i]);      { all arguments value }
        readln(f,b,fcs);       { function Co or Sinus }
      end;
  closefile(f);    { that is all for this file }
end;
end.
